#include <linux/config.h>
#include <linux/kernel.h>
#include "init301.h"

extern UCHAR  SiSGet310DRAMType(ULONG);
#ifdef CONFIG_FB_SIS_315
VOID SiSAutoThreshold	(USHORT  BaseAddr);
#endif

BOOLEAN SiSSetCRT2Group301(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp;

	SiSSetFlag = SiSSetFlag | ProgrammingCRT2;
	SiSSearchModeID(ROMAddr,ModeNo);

	temp=SiSGetRatePtrCRT2(ROMAddr,ModeNo);
	if (((temp&0x02)==0) && ((SiSVBInfo&CRT2DisplayFlag)==0))
		return(FALSE);
	SiSSaveCRT2Info(ModeNo);	
	SiSDisableBridge(HwDeviceExtension,BaseAddr);
	SiSUnLockCRT2(HwDeviceExtension,BaseAddr);
	SiSSetDefCRT2ExtRegs(BaseAddr);
	SiSSetCRT2ModeRegs(BaseAddr,ModeNo);
	if (SiSVBInfo&CRT2DisplayFlag) {
	  SiSLockCRT2(HwDeviceExtension,BaseAddr);
	  return 0;  
	}
	SiSGetCRT2Data(ROMAddr,ModeNo);
	if (SIS_IF_DEF_LVDS==1) {  
	  SiSGetLVDSDesData(ROMAddr,ModeNo);
	}
	SiSSetGroup1(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
	if (SIS_IF_DEF_LVDS==0) {
		SiSSetGroup2(BaseAddr,ROMAddr);	  
		SiSSetGroup3(BaseAddr);
		SiSSetGroup4(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
		SiSSetGroup5(BaseAddr,ROMAddr);
	} else {  
		if (SIS_IF_DEF_TRUMPION==0) {
			SiSModCRT1CRTC(ROMAddr,ModeNo);
		}
		SiSSetCRT2ECLK(ROMAddr,ModeNo,HwDeviceExtension);
	}

#ifdef	CONFIG_FB_SIS_315
	SiSAutoThreshold(BaseAddr);
#endif
	
	SiSOEM310Setting(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
	
	SiSEnableCRT2();
	SiSEnableBridge(HwDeviceExtension,BaseAddr);
	SiSSetLockRegs();
	SiSLockCRT2(HwDeviceExtension,BaseAddr);
 
	return 1;				
}

VOID SiSoverwriteregs(ULONG ROMAddr,USHORT BaseAddr)
{
	int i;
	USHORT  Part1Port; 
	int p1reg[0x29]={0x84,0x76,0x4B,0x21,0x00,0x00,0x00,0x00,0x1F,0x51,0x0C,0x10,0x44,0x90,0x1E,0xFF,
					  0x00,0x34,0x13,0x10,0x00,0x00,0x00,0x01,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
					  0x00,0x00,0x00,0x00,0x01,0x01,0x97,0x16,0xA3};
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	for(i=0;i<29;i++) {
		SiSSetReg1(Part1Port,(USHORT)i,(USHORT)p1reg[i]);
	}
}

VOID SiSSetDefCRT2ExtRegs(USHORT BaseAddr)
{
	USHORT  Part1Port,Part2Port,Part4Port;
	USHORT  temp;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	SiSSetReg1(Part1Port,0x02,0x40);
	SiSSetReg1(Part4Port,0x10,0x80);
	temp=(UCHAR)SiSGetReg1(SiSP3c4,0x16);
	temp=temp&0xC3;
	SiSSetReg1(SiSP3d4,0x35,temp);
		  
}
		  
USHORT SiSGetRatePtrCRT2(ULONG ROMAddr, USHORT ModeNo)
{										 
	SHORT  index;					  
	USHORT temp;						
	USHORT ulRefIndexLength;
	USHORT temp1;
	SHORT  LCDRefreshIndex[4]={0x0,0x0,0x03,0x01};
								
  
	if (ModeNo<0x14) return(0);									

	index=SiSGetReg1(SiSP3d4,0x33);									 
	index=index>>SelectCRT2Rate;			 
	index=index&0x0F;												
	if (index!=0) index--;
  
	if (SIS_IF_DEF_TRUMPION==1) {
		if (SiSVBInfo&SetSimuScanMode) {
			index=0;
		}
	}
	if (SiSSetFlag&ProgrammingCRT2) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (SIS_IF_DEF_LVDS==0) {
				temp=SiSLCDResInfo;
				temp1=LCDRefreshIndex[temp];
				if (index>temp1) {
					index=temp1;
				} 
			} else {
				index=0;
			}			
		}	
	}	  
  
	SiSREFIndex=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x05));	

	ulRefIndexLength =Ext2StructSize;
	do {
		temp=*((USHORT *)(ROMAddr+SiSREFIndex));					 
		if (temp==0xFFFF) break;
		temp=temp&ModeInfoFlag;
		if (temp<SiSModeType) break;

		SiSREFIndex=SiSREFIndex+ulRefIndexLength;						
		index--;
		if (index<0) {
			if (!(SiSVBInfo&SetCRT2ToRAMDAC)) {
				if (SiSVBInfo&SetInSlaveMode) {
					temp1=*((USHORT *)(ROMAddr+SiSREFIndex+0-Ext2StructSize));
					if (temp1&InterlaceMode) {
						index=0;	 
					}	  
				}
			} 
		}	
	} while(index>=0);
  
	SiSREFIndex=SiSREFIndex-ulRefIndexLength;						  
  
	if ((SiSSetFlag&ProgrammingCRT2)) {
		temp1=SiSAjustCRT2Rate(ROMAddr);
	} else {
		temp1=0;
	}
			  
  return(0x01|(temp1<<1));
}

BOOLEAN SiSAjustCRT2Rate(ULONG ROMAddr)
{
	USHORT tempax,temp,tempbx=0;
	USHORT tempextinfoflag;
	tempax=0;

	if (SIS_IF_DEF_LVDS==0) {
		if (SiSVBInfo&SetCRT2ToRAMDAC) {
			tempax=tempax|SupportRAMDAC2;
		}
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempax=tempax|SupportLCD;
			if (SiSLCDResInfo!=Panel1280x1024) {
				temp=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x0a)); 
				if (temp>=9) {
					tempax=0;
				}		 
			}
		}
		if (SiSVBInfo&(SetCRT2ToAVIDEO|SetCRT2ToSVIDEO|SetCRT2ToSCART)) {
			tempax=tempax|SupportTV;
			if (!(SiSVBInfo&SetPALTV)) {
				tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); 
				if (tempextinfoflag&NoSupportSimuTV) {
			 		if (SiSVBInfo&SetInSlaveMode) {
						if (!(SiSVBInfo&SetNotSimuTVMode)) {
							return 0;
						} 
					}
				} 
			}
		}
		tempbx=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x05));	
	} else {  
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempax=tempax|SupportLCD;
			temp=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x0a)); 
			if (temp>0x08) { 
				return 0;
			}
			if (SiSLCDResInfo<Panel1024x768) {
				if (temp>0x07) { 
					return 0;
				}
				if (temp==0x04) { 
			 		return 0;
				}
			}
		}
	}

	for(;SiSREFIndex>tempbx;SiSREFIndex-=Ext2StructSize) {
		tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); 
		if (tempextinfoflag&tempax) {
			return 1;
		}
	} 

	for(SiSREFIndex=tempbx;;SiSREFIndex+=Ext2StructSize) {
		tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); 
		if (tempextinfoflag==0x0FFFF) {
			return 0;
		}
		if (tempextinfoflag&tempax) {
			return 1;
		}
	}
	return(FALSE);
}

VOID SiSSaveCRT2Info(USHORT ModeNo) {
	USHORT temp1,temp2,temp3;
  
	temp1=(SiSVBInfo&SetInSlaveMode)>>8;
	temp2=~(SetInSlaveMode>>8);
	temp3=(UCHAR)SiSGetReg1(SiSP3d4,0x31);
	temp3=((temp3&temp2)|temp1);
	SiSSetReg1(SiSP3d4,0x31,(USHORT)temp3);
	temp3=(UCHAR)SiSGetReg1(SiSP3d4,0x35);
	temp3=temp3&0xF3;
	SiSSetReg1(SiSP3d4,0x35,(USHORT)temp3);
}

VOID SiSDisableLockRegs() {
	UCHAR temp3;
	temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x32);
	temp3=temp3&0xDF;
	SiSSetReg1(SiSP3c4,0x32,(USHORT)temp3);
}

VOID SiSDisableCRT2() {
	UCHAR temp3;
	temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x1E);
	temp3=temp3&0xDF;
	SiSSetReg1(SiSP3c4,0x1E,(USHORT)temp3);
}



VOID SiSDisableBridge(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT  BaseAddr)
{
	USHORT  Part2Port,Part1Port;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;

	if (SIS_IF_DEF_LVDS==0) {
		SiSSetRegANDOR(Part2Port,0x00,0xDF,0x00);  
		SiSSetRegOR(Part1Port,0x00,0x80);  
		SiSDisableLockRegs();	
		SiSSetRegAND(Part1Port,0x2E,0x7F);  
		SiSDisableCRT2();	
	} else {
		SiSDisableLockRegs();
		SiSDisableCRT2();
		if (SIS_IF_DEF_TRUMPION==0) {
			SiSUnLockCRT2(HwDeviceExtension,BaseAddr);
			SiSSetRegANDOR(Part1Port,0x02,0xFF,0x40); 
		}
	}
}

VOID SiSGetCRT2Data(ULONG ROMAddr,USHORT ModeNo)
{
	if (SIS_IF_DEF_LVDS==0) { 
		SiSGetCRT2Data301(ROMAddr,ModeNo);
		return;
	} else { 
		SiSGetCRT2DataLVDS(ROMAddr,ModeNo);
		return;
	}
}

VOID SiSGetCRT2DataLVDS(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,OldREFIndex;  

	OldREFIndex=(USHORT)SiSREFIndex;			
	SiSGetResInfo(ROMAddr,ModeNo);
	SiSGetCRT2Ptr(ROMAddr,ModeNo);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex));
	tempax=tempax&0x0FFF;
	SiSVGAHT=tempax;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+1));
	tempax=tempax>>4;
	tempax=tempax&0x07FF;
	SiSVGAVT=tempax;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+3));
	tempax=tempax&0x0FFF;
	tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+4));
	tempbx=tempbx>>4;
	tempbx=tempbx&0x07FF;

	SiSHT=tempax;
	SiSVT=tempbx;

	if (SIS_IF_DEF_TRUMPION==0) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (!(SiSLCDInfo&LCDNonExpanding)) {
				if (SiSLCDResInfo==Panel800x600) {
					tempax=800;
					tempbx=600;
				} else if (SiSLCDResInfo==Panel1024x768) {
					tempax=1024;
					tempbx=768;
				} else {
					tempax=1280;
					tempbx=1024;
				}
				SiSHDE=tempax;
				SiSVDE=tempbx;
			}
		}
	}
	SiSREFIndex=OldREFIndex;			
	return;
}

VOID SiSGetCRT2Data301(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,modeflag1,OldREFIndex;
	USHORT tempal,tempah,tempbl;
  
	OldREFIndex=(USHORT)SiSREFIndex;			
	SiSRVBHRS=50;SiSNewFlickerMode=0;SiSRY1COE=0;
	SiSRY2COE=0;SiSRY3COE=0;SiSRY4COE=0;

	SiSGetResInfo(ROMAddr,ModeNo);
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		SiSGetRAMDAC2DATA(ROMAddr,ModeNo);
		SiSREFIndex=OldREFIndex;			
		return;
	}
	SiSGetCRT2Ptr(ROMAddr,ModeNo);

	tempal=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex+4));
	tempax=tempal|(((tempah<<8)>>7)&0xFF00);
	SiSRVBHCMAX=tempax;

	tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+1));
	SiSRVBHCFACT=tempal;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+2));
	SiSVGAHT=(tempax&0x0FFF);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+3));
	SiSVGAVT=((tempax>>4)&0x07FF);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+5));
	tempax=(tempax&0x0FFF);
	tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+6));
	tempbx=((tempbx>>4)&0x07FF);
	tempbl=tempbx&0x00FF;

	if (SiSVBInfo&SetCRT2ToTV) {
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+5));
		tempax=(tempax&0x0FFF);
		SiSHDE=tempax;
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+6));
		tempax=((tempax>>4)&0x07FF);
		SiSVDE=tempax;
	 
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+8));
		tempbl=(tempax>>8);
		tempax=tempax&0x0FFF;  
		modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
		if (modeflag1&HalfDCLK) {
			tempax=*((USHORT *)(ROMAddr+SiSREFIndex+10));
		}
		SiSRVBHRS=tempax;
		SiSNewFlickerMode=(tempbl&0x080);

		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+12));
		SiSRY1COE=(tempax&0x00FF);
		SiSRY2COE=((tempax&0xFF00)>>8);
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+14));
		SiSRY3COE=(tempax&0x00FF);
		SiSRY4COE=((tempax&0xFF00)>>8);
		if (!(SiSVBInfo&SetPALTV)) { 
			tempax=NTSCHT;
			tempbx=NTSCVT;
		} else {
			tempax=PALHT;
			tempbx=PALVT;
		} 
	}
	SiSHT=tempax;
	SiSVT=tempbx;
	if (!(SiSVBInfo&SetCRT2ToLCD)) {
		SiSREFIndex=OldREFIndex;			
		return;
	}

	tempax=1024;
	if (SiSVGAVDE==350) {		
		tempbx=560;
	} else if (SiSVGAVDE==400) {
		tempbx=640;
	} else {
		tempbx=768;
	}

	if (SiSLCDResInfo==Panel1280x1024) {
		tempax=1280;		  
		if (SiSVGAVDE==360) {
			tempbx=768;
		} else if (SiSVGAVDE==375) {
			tempbx=800;		 
		} else if (SiSVGAVDE==405) {
			tempbx=864;		 
		} else {
			tempbx=1024;
		}  
	}

	SiSHDE=tempax;
	SiSVDE=tempbx; 
	SiSREFIndex=OldREFIndex;			
	return; 
}

VOID SiSGetResInfo(ULONG ROMAddr,USHORT ModeNo)
{ 
	USHORT temp,xres,yres,modeflag1;
	if (ModeNo<=0x13) {
		temp=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x05));	
		xres=SiSStResInfo[temp][0];
		yres=SiSStResInfo[temp][1];
	} else {
		temp=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x0a));	
		xres=SiSModeResInfo[temp][0];  
		yres=SiSModeResInfo[temp][1];  
		modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
		if (modeflag1&HalfDCLK) { xres=xres*2;}
		if (modeflag1&DoubleScanMode) {yres=yres*2;}
	}
	if (!(SiSLCDResInfo==Panel1024x768)) {
		if (yres==400) yres=405;
		if (yres==350) yres=360;
		if (SiSSetFlag&LCDVESATiming) {
			if (yres==360) yres=375;	
		}			  
	}
	SiSVGAHDE=xres;
	SiSHDE=xres;
	SiSVGAVDE=yres;
	SiSVDE=yres;
}

VOID SiSGetLVDSDesData(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT old_REFIndex,tempax;

	old_REFIndex=(USHORT)SiSREFIndex; 
	SiSREFIndex=SiSGetLVDSDesPtr(ROMAddr,ModeNo);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex));
	tempax=tempax&0x0FFF;
	SiSLCDHDES=tempax;

	if (SiSLCDInfo&LCDNonExpanding) { 
		if (SiSLCDResInfo>=Panel1024x768) {
			if (ModeNo<=0x13) {
				SiSLCDHDES=320;
			}
		}
	}

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+1));
	tempax=tempax>>4;
	tempax=tempax&0x07FF;
	SiSLCDVDES=tempax;

	SiSREFIndex=old_REFIndex; 
	return;  
}


VOID SiSGetRAMDAC2DATA(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,tempbh,modeflag1,t2, t1=0;
	SiSRVBHCMAX=1;SiSRVBHCFACT=1;
	if (ModeNo<=0x13) {
		tempax=*((UCHAR *)(ROMAddr+SiSREFIndex+10)); 
		tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+16));
	} else {
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+0x2)); 
		t1=t1&0x03F;  
		t1=t1*CRT1Len;
		SiSREFIndex=*((USHORT *)(ROMAddr+CRT1TablePtrOffset));		
		SiSREFIndex=SiSREFIndex+t1;
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+0));
		t2=*((UCHAR *)(ROMAddr+SiSREFIndex+14));
		tempax=(t1&0xFF)|((t2&0x03)<<8);
		tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+6));
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+13));
		t1=(t1&0x01)<<2;
	}

	tempbh=tempbx>>8;
	tempbh=((tempbh&0x20)>>4)|(tempbh&0x01);
	tempbh=tempbh|t1;
	tempbx=(tempbx&0xFF)|(tempbh<<8);
	tempax=tempax+5;
	modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (modeflag1&Charx8Dot) {
		tempax=tempax*8;
	} else {
		tempax=tempax*9;
	}
			
	SiSVGAHT=tempax;
	SiSHT=tempax;
	tempbx++;
	SiSVGAVT=tempbx;
	SiSVT=tempbx;
}

VOID SiSGetCRT2Ptr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempcl,tempbx,tempal,tempax,CRT2PtrData;

	if (SIS_IF_DEF_LVDS==0) {
		if (SiSVBInfo&SetCRT2ToLCD) {				  
			tempbx=0; 
			tempcl=LCDDataLen;
			if (SiSLCDResInfo==Panel1024x768) {
				tempbx=0;
			} else if (SiSLCDResInfo==Panel1280x1024) {
				tempbx=1;
			}
			if (!(SiSSetFlag&LCDVESATiming)) tempbx+=5;
		} else if (SiSVBInfo&SetPALTV) {
			tempcl=TVDataLen;
			tempbx=3;
		} else {
			tempbx=4;
			tempcl=TVDataLen;
		}  
		if (SiSSetFlag&TVSimuMode) {
			tempbx=tempbx+4;			 
		}
		if (ModeNo<=0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));	
		} else {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));	 
		}
		tempal=tempal&0x1F;

		tempax=tempal*tempcl;
		SiSREFIndex=*((USHORT *)(ROMAddr+CRT2PtrDataPtrOffset)); 
		SiSREFIndex = *((USHORT *)(ROMAddr+SiSREFIndex+tempbx*2));
		SiSREFIndex+=tempax;
	} else { 
		tempcl=LVDSDataLen;
		tempbx=SiSLCDResInfo-Panel800x600;
		if (SiSLCDInfo&LCDNonExpanding) {
			tempbx=tempbx+3;
		}
		if (ModeNo<=0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));		
		} else {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));		
		}
		tempal=tempal&0x1F;
		tempax=tempal*tempcl;
		CRT2PtrData=*((USHORT *)(ROMAddr+ADR_CRT2PtrData)); 
		SiSREFIndex=*((USHORT *)(ROMAddr+CRT2PtrData+tempbx*2));
		SiSREFIndex+=tempax;
	}
}

VOID SiSUnLockCRT2(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr)
{
	UCHAR temp3;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
  
	if (HwDeviceExtension->jChipID == SIS_GlamourII) {
		temp3=(UCHAR)SiSGetReg1(Part1Port,0x2f);
		temp3=temp3|0x01;
		SiSSetReg1(Part1Port,0x2f,(USHORT)temp3);
	}
	else if (HwDeviceExtension->jChipID == SIS_GlamourII) {
		temp3=(UCHAR)SiSGetReg1(Part1Port,0x24);
		temp3=temp3|0x01;
		SiSSetReg1(Part1Port,0x24,(USHORT)temp3);
	}

}

VOID SiSSetCRT2ModeRegs(USHORT BaseAddr,USHORT ModeNo)
{
	USHORT i,j;
	USHORT tempah=0,temp3;
	SHORT  tempcl;
	USHORT  Part4Port;
	USHORT  Part1Port;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	for(i=0,j=4;i<3;i++,j++) {
		SiSSetReg1(Part1Port,j,0);
	}
  
	tempcl=(USHORT)SiSModeType;
	if (ModeNo>0x13) {
		tempcl=tempcl-ModeVGA; 
		if (tempcl>=0) {
#ifdef CONFIG_FB_SIS_315
			tempah=(0x008>>tempcl);
			if (tempah==0) tempah=1;
			tempah |= 0x040;
#else
			tempah=((0x010>>tempcl)|0x080);
#endif
		}
	} else {
#ifdef CONFIG_FB_SIS_315
		tempah=0x040;
#else
		tempah=0x080;
#endif
	}
	
	if (SiSVBInfo&SetInSlaveMode) {
#ifdef CONFIG_FB_SIS_315
		tempah=(tempah^0x050);
#else
		tempah=(tempah^0x0A0);
#endif
	}

	if (SiSVBInfo&CRT2DisplayFlag) {
		tempah=0;
	}  
	SiSSetReg1(Part1Port,0,tempah);

	if (SIS_IF_DEF_LVDS==0) { 
		tempah=0x01;
		if (!(SiSVBInfo&SetInSlaveMode)) {
			tempah=(tempah|0x02);
		}
		if (!(SiSVBInfo&SetCRT2ToRAMDAC)) {
			tempah=(tempah^0x05);
			if (!(SiSVBInfo&SetCRT2ToLCD)) {
				tempah=(tempah^0x01);
			}
		}
#ifdef CONFIG_FB_SIS_315
		if (SiSVBInfo&CRT2DisplayFlag) {
			tempah=0;
		}
		temp3 = SiSGetReg1(Part1Port, 0x2E);
		temp3 = (temp3&0xF8)|tempah;
		SiSSetReg1(Part1Port,0x2E,temp3);
#else
		tempah=(tempah<<5)&0xFF;
		if (SiSVBInfo&CRT2DisplayFlag) {
			tempah=0;
		}
		SiSSetReg1(Part1Port,0x01,tempah);
		tempah=tempah>>5;
#endif
	
		if ((SiSModeType==ModeVGA)&&(!(SiSVBInfo&SetInSlaveMode))) {
			tempah=tempah|0x010;
		}
		if (SiSLCDResInfo!=Panel1024x768) {
			tempah=tempah|0x080;
		}
		if (SiSVBInfo&SetCRT2ToTV) {
			if (SiSVBInfo&SetInSlaveMode) {
				tempah=tempah|0x020;
			}
		}
  
		temp3=(UCHAR)SiSGetReg1(Part4Port,0x0D);
		temp3=temp3&(~0x0BF);
		temp3=temp3|tempah;
		SiSSetReg1(Part4Port,0x0D,(USHORT)temp3);
	} else { 
		tempah=0;
		if (!(SiSVBInfo&SetInSlaveMode)) {
			tempah=tempah|0x02;
		}
		tempah=(tempah<<5)&0x0FF;
		if (SiSVBInfo&CRT2DisplayFlag) {
			tempah=0;
		}
		SiSSetReg1(Part1Port,0x01,tempah);
	}
}

VOID SiSSetGroup1(USHORT  BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	if (SIS_IF_DEF_LVDS==0) {  
		SiSSetGroup1_301(BaseAddr,ROMAddr,ModeNo, HwDeviceExtension);
	} else {  
		SiSSetGroup1_LVDS(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
	}
}
VOID SiSSetGroup1_LVDS(USHORT  BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp1,temp2,tempcl,tempch,tempbh,tempal,tempah,tempax,tempbx;
	USHORT tempcx,OldREFIndex,lcdhdee;
	USHORT  Part1Port;
	USHORT temppush1,temppush2;
	unsigned long int tempeax,tempebx,tempecx,templong;

	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	OldREFIndex=(USHORT)SiSREFIndex;			

	SiSSetCRT2Offset(Part1Port,ROMAddr);
	SiSSetCRT2FIFO(Part1Port,ROMAddr,ModeNo,HwDeviceExtension);
	SiSSetCRT2Sync(BaseAddr,ROMAddr,ModeNo);
		  
	temp1=(SiSVGAHT-1)&0x0FF;				
	SiSSetReg1(Part1Port,0x08,temp1);
	temp1=(((SiSVGAHT-1)&0xFF00)>>8)<<4;
	SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);
  
	temp1=(SiSVGAHDE+12)&0x0FF;				  
	SiSSetReg1(Part1Port,0x0A,temp1);
  
	temp1=SiSVGAHDE+12;		
	temp2=(SiSVGAHT-SiSVGAHDE)>>2;		
	temp1=temp1+temp2;
	temp2=(temp2<<1)+temp1;
	tempcl=temp2&0x0FF;
		  
	SiSSetReg1(Part1Port,0x0B,(USHORT)(temp1&0x0FF));
	tempah=(temp1&0xFF00)>>8;
	tempbh=((((SiSVGAHDE+12)&0xFF00)>>8)<<4)&0x0FF;
	tempah=tempah|tempbh;
	SiSSetReg1(Part1Port,0x0C,tempah);
	SiSSetReg1(Part1Port,0x0D,tempcl);		 
	tempcx=(SiSVGAVT-1);
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x0E,tempah);		  
	tempbx=SiSVGAVDE-1;
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x0F,tempah);		 
	tempah=((tempbx&0xFF00)<<3)>>8;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part1Port,0x12,tempah);
  
	tempbx=(SiSVGAVT+SiSVGAVDE)>>1;				 
	tempcx=((SiSVGAVT-SiSVGAVDE)>>4)+tempbx+1;  
		  
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x10,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	tempah=((tempbh<<4)&0x0FF)|(tempcx&0x0F);
	SiSSetReg1(Part1Port,0x11,tempah);
		  
	SiSSetRegANDOR(Part1Port,0x13,~0x03C,tempah);
  
	tempax=SiSLCDHDES;
	tempbx=SiSHDE;
	tempcx=SiSHT;
	tempcx=tempcx-tempbx; 
  
	tempax=tempax+tempbx; 
	tempbx=SiSHT;
	if (tempax>=tempbx) {
		tempax=tempax-tempbx;
	}
  
	lcdhdee=tempax;
	tempcx=tempcx>>2;	  
	tempcx=tempcx+tempax; 
	if (tempcx>=tempbx) {
		tempcx=tempcx-tempbx;
	}
  
	tempax=tempcx;
	tempax=tempax>>3; 
	tempah=tempax&0x0FF;
	SiSSetReg1(Part1Port,0x14,tempah); 
	tempah=tempah+2;
	tempah=tempah+0x01F;
	tempcl=tempcx&0x0FF;
	tempcl=tempcl&0x07;
	tempcl=(tempcl<<5)&0xFF; 
	tempah=tempah|tempcl;
	SiSSetReg1(Part1Port,0x15,tempah); 
	tempbx=lcdhdee;		 
	tempcx=SiSLCDHDES;		 
	tempah=(tempcx&0xFF);
	tempah=tempah&0x07;	
	SiSSetReg1(Part1Port,0x1A,tempah); 
	tempcx=tempcx>>3;	  
	tempah=(tempcx&0xFF);
	SiSSetReg1(Part1Port,0x16,tempah); 
	tempbx=tempbx>>3;	  
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x17,tempah); 

	tempcx=SiSVGAVT;
	tempbx=SiSVGAVDE;
	tempcx=tempcx-tempbx;			
	tempbx=SiSLCDVDES;					
	temppush1=tempbx;				 
	if (SIS_IF_DEF_TRUMPION==0) {
		if (SiSLCDResInfo==Panel800x600) {
			tempax=600;
		} else {
			tempax=768;
		}
	} else {
		tempax=SiSVGAVDE;
	}
	tempbx=tempbx+tempax;
	tempax=SiSVT;				
	if (tempbx>=SiSVT) {
		tempbx=tempbx-tempax;
	}
	temppush2=tempbx;	  
	tempcx=tempcx>>1;
	tempbx=tempbx+tempcx;
	tempbx++;	  
	if (tempbx>=tempax) {
		tempbx=tempbx-tempax;
	}
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x18,tempah); 
	tempcx=tempcx>>3;
	tempcx=tempcx+tempbx;
	tempcx++;				 
	tempah=tempcx&0xFF;
	tempah=tempah&0x0F;
	tempah=tempah|0x030;
	SiSSetRegANDOR(Part1Port,0x19,~0x03F,tempah); 
	tempbh=(tempbx&0xFF00)>>8;
	tempbh=tempbh&0x07;
	tempah=tempbh;
	tempah=(tempah<<3)&0xFF;		
  
	tempbx=SiSVGAVDE;
	if (tempbx!=SiSVDE) {
		tempah=tempah|0x40;
	}
	SiSSetRegANDOR(Part1Port,0x1A,0x07,tempah); 
	tempecx=SiSVGAVT;
	tempebx=SiSVDE;
	tempeax=SiSVGAVDE;
	tempecx=tempecx-tempeax;		
	tempeax=tempeax*64;
	templong=tempeax/tempebx;
	if (templong*tempebx<tempeax) {
		templong++;
	}
	tempebx=templong;	  
	if (SiSSetFlag&EnableLVDSDDA) {
		tempebx=tempebx&0x03F;
	}
	tempah=(USHORT)(tempebx&0x0FF);
	SiSSetReg1(Part1Port,0x1E,tempah); 
	tempbx=temppush2;	  
	tempcx=temppush1;	  
	tempbh=(tempbx&0xFF00)>>8;
	tempah=tempah&0x07;
	tempah=tempbh;
	tempah=tempah<<3;
	tempch=(tempcx&0xFF00)>>8;
	tempch=tempah&0x07;
	tempah=tempah|tempch;
	SiSSetReg1(Part1Port,0x1D,tempah); 
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x1C,tempah); 
	tempah=tempcx&0xFF;
	SiSSetReg1(Part1Port,0x1B,tempah); 
  
	tempecx=SiSVGAHDE;
	tempebx=SiSHDE;
	tempeax=tempecx;
	tempeax=tempeax<<6;
	tempeax=tempeax<<10;
	tempeax=tempeax/tempebx;
	if (tempebx==tempecx) {
		tempeax=65535;
	}
	tempecx=tempeax;
	tempeax=SiSVGAHT;
	tempeax=tempeax<<6;
	tempeax=tempeax<<10;
	tempeax=tempeax/tempecx;
	tempecx=tempecx<<16;
	tempeax=tempeax-1;
	tempax=(USHORT)(tempeax&0x00FFFF);
	tempcx=tempax;
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x1F,tempah); 
	tempbx=SiSVDE;
	tempbx--;				 
	if (SiSSetFlag&EnableLVDSDDA) {
		tempbx=1;
	}
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<3)&0xFF;
	tempch=(tempcx&0xFF00)>>8;
	tempch=tempch&0x07;
	tempah=tempah|tempch;
	SiSSetReg1(Part1Port,0x20,tempah); 
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x21,tempah); 
	tempecx=tempecx>>16;			 
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (temp1&HalfDCLK) {
		tempecx=tempecx>>1;
	}
	tempcx=(USHORT)(tempecx&0x0FFFF);
	tempah=(tempcx&0xFF00)>>8;
	SiSSetReg1(Part1Port,0x22,tempah); 
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x23,tempah); 
	if (SIS_IF_DEF_TRUMPION==1) {
		tempal=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x05));	
		if (ModeNo>0x13) {
			SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
			SiSGetRatePtrCRT2(ROMAddr,ModeNo);
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));		
			tempal=tempal&0x1F;
		}
		tempah=0x80;
		tempal=tempal*tempah;
		SiSREFIndex= offset_Zurac; 
		SiSREFIndex=SiSREFIndex+tempal;
		SiSSetTPData();	
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
	}
 
	SiSREFIndex=OldREFIndex;			
	return;
}

VOID SiSSetTPData()
{
	return;
}

VOID SiSSetGroup1_301(USHORT  BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp1,temp2,tempcl,tempch,tempbl,tempbh,tempal,tempah,tempax,tempbx;
	USHORT tempcx,OldREFIndex;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	OldREFIndex=(USHORT)SiSREFIndex;			

	SiSSetCRT2Offset(Part1Port,ROMAddr);
	SiSSetCRT2FIFO(Part1Port,ROMAddr,ModeNo,HwDeviceExtension);
	SiSSetCRT2Sync(BaseAddr,ROMAddr,ModeNo);

	SiSGetCRT1Ptr(ROMAddr);

#ifdef CONFIG_FB_SIS_315
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (temp1&HalfDCLK) {
		temp1=(SiSVGAHT/2-1)&0x0FF;				
		SiSSetReg1(Part1Port,0x08,temp1);
		temp1=(((SiSVGAHT/2-1)&0xFF00)>>8)<<4;
		SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);
	} else {
		temp1=(SiSVGAHT-1)&0x0FF;				
		SiSSetReg1(Part1Port,0x08,temp1);
		temp1=(((SiSVGAHT-1)&0xFF00)>>8)<<4;
		SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);
	}
#else  
	temp1=(SiSVGAHT-1)&0x0FF;				
	SiSSetReg1(Part1Port,0x08,temp1);
	temp1=(((SiSVGAHT-1)&0xFF00)>>8)<<4;
	SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);
#endif
 
  
#ifdef CONFIG_FB_SIS_315
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (temp1&HalfDCLK)
		temp1=(SiSVGAHDE/2+16)&0x0FF;				  
	else
		temp1=(SiSVGAHDE+16)&0x0FF;				  
	SiSSetReg1(Part1Port,0x0A,temp1);
#else  
	temp1=(SiSVGAHDE+12)&0x0FF;				  
	SiSSetReg1(Part1Port,0x0A,temp1);
#endif
  
#ifdef CONFIG_FB_SIS_315
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (temp1&HalfDCLK) {
		temp1=SiSVGAHDE/2+16;		
		temp2=((SiSVGAHT-SiSVGAHDE)/2)>>2;		
	} else {
		temp1=SiSVGAHDE+16;		
		temp2=(SiSVGAHT-SiSVGAHDE)>>2;		
	}
	temp1=temp1+temp2;
	temp2=temp2+temp1;
#else 
  temp1=SiSVGAHDE+12;		
  temp2=(SiSVGAHT-SiSVGAHDE)>>2;		
  temp1=temp1+temp2;
  temp2=(temp2<<1)+temp1;
#endif
  tempcl=temp2&0x0FF;
  if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempbl=*((UCHAR *)(ROMAddr+SiSREFIndex+4));	 
		tempbh=*((UCHAR *)(ROMAddr+SiSREFIndex+14));	 
		temp1=((tempbh>>6)<<8)|tempbl;				  
		temp1=(temp1-1)<<3;
		tempcl=*((UCHAR *)(ROMAddr+SiSREFIndex+5));	 
		tempch=*((UCHAR *)(ROMAddr+SiSREFIndex+15));	 
		tempcl=tempcl&0x01F;
		tempch=(tempch&0x04)<<(6-2);
		tempcl=((tempcl|tempch)-1)<<3;	 
#ifdef CONFIG_FB_SIS_315
		temp1 += 16;
		tempcl += 16;

		temp2=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
		if (temp2&HalfDCLK) {
			if (tempcl>(SiSVGAHT/2))
			tempcl = SiSVGAHT/2;
		} else {
			if (tempcl>SiSVGAHT)
			tempcl = SiSVGAHT;
		}
#endif
	}
	SiSSetReg1(Part1Port,0x0B,(USHORT)(temp1&0x0FF));
	tempah=(temp1&0xFF00)>>8;
	tempbh=((((SiSVGAHDE+12)&0xFF00)>>8)<<4)&0x0FF;
	tempah=tempah|tempbh;
	SiSSetReg1(Part1Port,0x0C,tempah);
	SiSSetReg1(Part1Port,0x0D,tempcl);		 
	tempcx=(SiSVGAVT-1);
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x0E,tempah);		  
	tempbx=SiSVGAVDE-1;
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x0F,tempah);		 
	tempah=((tempbx&0xFF00)<<3)>>8;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part1Port,0x12,tempah);
  
	tempbx=(SiSVGAVT+SiSVGAVDE)>>1;				 
	tempcx=((SiSVGAVT-SiSVGAVDE)>>4)+tempbx+1;  
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempbx=*((UCHAR *)(ROMAddr+SiSREFIndex+8));	 
		temp1=*((UCHAR *)(ROMAddr+SiSREFIndex+7));	 
		if (temp1&0x04) {
			tempbx=tempbx|0x0100;
		}
		if (temp1&0x080) {
			tempbx=tempbx|0x0200;
		}
		temp1=*((UCHAR *)(ROMAddr+SiSREFIndex+13));	 
		if (temp1&0x08) {
			tempbx=tempbx|0x0400;
		}
		tempcl= *((UCHAR *)(ROMAddr+SiSREFIndex+9));	 
		tempcx=(tempcx&0xFF00)|(tempcl&0x00FF);
	}
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x10,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	tempah=((tempbh<<4)&0x0FF)|(tempcx&0x0F);
	SiSSetReg1(Part1Port,0x11,tempah);

	if (HwDeviceExtension->jChipID == SIS_Glamour) {
		tempah=0x10;
		if ((SiSLCDResInfo!=Panel1024x768)&&(SiSLCDResInfo==Panel1280x1024)) {
			tempah=0x20;
		}	
	} else {
		if (HwDeviceExtension->jChipID == SIS_GlamourII) {
			tempah=0x10;
			if ((SiSLCDResInfo!=Panel1024x768)&&(SiSLCDResInfo==Panel1280x1024)) {
				tempah=0x20;
			}
		}
	}
	if (SiSVBInfo&SetCRT2ToTV) {
		tempah=0x08;
	}
#ifdef CONFIG_FB_SIS_315
	tempah >>=2;
	SiSSetRegANDOR(Part1Port,0x2D,~0x00F,tempah);
#else  
	SiSSetRegANDOR(Part1Port,0x13,~0x03C,tempah);
#endif

#ifdef CONFIG_FB_SIS_315
	SiSSetRegAND(Part1Port,0x13,0xEF);  
	tempah=0;
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (temp1&DoubleScanMode)
		tempah |= 0x80;
	if (temp1&HalfDCLK)
		tempah |= 0x80;
	SiSSetRegANDOR(Part1Port,0x2C,~0x0C0,tempah);
#endif

	if (!(SiSVBInfo&SetInSlaveMode)) {
		SiSREFIndex=OldREFIndex;
		return;
	}
	if (SiSVBInfo&SetCRT2ToTV) {
		tempax=0xFFFF;		
	} else {
		tempax=SiSGetVGAHT2();
	}
	tempcl=0x08;						
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (!(temp1&Charx8Dot)) {							  
		tempcl=0x09;
	}
	if (tempax>=SiSVGAHT) {
		tempax=SiSVGAHT;
	}
	if (temp1&HalfDCLK) {
		tempax=tempax>>1;
	}
	tempax=(tempax/tempcl)-5;
	tempbl=tempax;
  
	tempah=0xFF;			 
	SiSSetReg1(Part1Port,0x03,tempah);

	tempax=SiSVGAHDE;					 
	if (temp1&HalfDCLK) {
		tempax=tempax>>1;
	}
	tempax=(tempax/tempcl)-1;
	tempbh=tempax;
	SiSSetReg1(Part1Port,0x04,tempax);
  
	tempah=tempbh;
	if (SiSVBInfo&SetCRT2ToTV) {
		tempah=tempah+2;
	}
	SiSSetReg1(Part1Port,0x05,tempah); 
	SiSSetReg1(Part1Port,0x06,0x03);	
											 
	tempcx=(tempbl+tempbh)>>1;
	tempah=(tempcx&0xFF)+2;

	if (SiSVBInfo&SetCRT2ToTV) {
		tempah=tempah-1;	
		if (!(temp1&HalfDCLK)) {
			if ((temp1&Charx8Dot)) {
				tempah=tempah+4;
				if (SiSVGAHDE>=800) {
					tempah=tempah-6;
				}
			}
		}
	} else {
		if (!(temp1&HalfDCLK)) {
			tempah=tempah-4;
			if (SiSVGAHDE>=800) {
				tempah=tempah-7;
				if (SiSModeType==ModeEGA) {
					if (SiSVGAVDE==1024) {
						tempah=tempah+15;
						if (SiSLCDResInfo!=Panel1280x1024) {
							tempah=tempah+7;
						}  
					}	 
				}
				if (SiSVGAHDE>=1280) {
					tempah=tempah+28;
				}
			}
		}
	}
  
	SiSSetReg1(Part1Port,0x07,tempah);
  
	SiSSetReg1(Part1Port,0x08,0);	 
	SiSSetReg1(Part1Port,0x18,0x03); 
	SiSSetReg1(Part1Port,0x19,0); 
	SiSSetReg1(Part1Port,0x09,0xFF); 
  
	tempcx=0x121;
	tempcl=0x21;
	tempch=0x01;
	tempbx=SiSVGAVDE;					 
	if (tempbx==360) tempbx=350;
	if (tempbx==375) tempbx=350;
	if (tempbx==405) tempbx=400;	
	tempbx--;
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x0E,tempah);
	SiSSetReg1(Part1Port,0x10,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	if (tempbh&0x01) {
		tempcl=tempcl|0x0A;
	}
	tempah=0;tempal=0x0B;
	if (temp1&DoubleScanMode) {
		tempah=tempah|0x080;
	}
	if (tempbh&0x02) {
		tempcl=tempcl|0x040;
		tempah=tempah|0x020;
	}
	SiSSetReg1(Part1Port,0x0B,tempah);
	if (tempbh&0x04) {
		tempch=tempch|0x06; 
	}

	SiSSetReg1(Part1Port,0x11,0);  
  
	tempax=SiSVGAVT-tempbx;			 
	tempax=tempax>>2;
	temp2=tempax;			
	tempax=tempax<<1;
	tempbx=tempax+tempbx;
	if ((SiSSetFlag&TVSimuMode)&&(SiSVBInfo&SetPALTV)&&(SiSVGAHDE==800)) {
		tempbx=tempbx+40;
	}
	tempah=(tempbx&0x0FF);
	SiSSetReg1(Part1Port,0x0C,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	if (tempbh&0x01) {
		tempcl=tempcl|0x04;
	}
	if (tempbh&0x02) {
		tempcl=tempcl|0x080;
	}
	if (tempbh&0x04) {
		tempch=tempch|0x08;
	}

	tempax=temp2;			
	tempax=(tempax>>2)+1;
	tempbx=tempbx+tempax;
	tempah=(tempbx&0x0FF)&0x0F;
	SiSSetReg1(Part1Port,0x0D,tempah);  
	tempbl=tempbx&0x0FF;
	if (tempbl&0x10) {
		tempch=tempch|0x020;
	}
  
	tempah=tempcl;
	SiSSetReg1(Part1Port,0x0A,tempah); 
	tempah=tempch;
	SiSSetReg1(Part1Port,0x17,tempah); 
	tempax=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	tempah=(tempax&0xFF00)>>8;
	tempah=(tempah>>1)&0x09;
	SiSSetReg1(Part1Port,0x16,tempah); 
	SiSSetReg1(Part1Port,0x0F,0);	 
	SiSSetReg1(Part1Port,0x12,0);	 
	SiSSetReg1(Part1Port,0x1A,0);	 
  
	SiSREFIndex=OldREFIndex;			
}

#ifdef	CONFIG_FB_SIS_315
VOID SiSAutoThreshold	(USHORT  BaseAddr)
{
	USHORT  temp1;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	temp1=SiSGetReg1(Part1Port,0x1);
	temp1 |= 0x40;
	SiSSetReg1(Part1Port,0x1,temp1); 
}
#endif

VOID SiSSetCRT2Offset(USHORT Part1Port,ULONG ROMAddr)
{
	USHORT offset;
	if (SiSVBInfo&SetInSlaveMode) {
		return;
	}
	offset=SiSGetOffset(ROMAddr);
	SiSSetReg1(Part1Port,0x07,(USHORT)(offset&0xFF));
	SiSSetReg1(Part1Port,0x09,(USHORT)((offset&0xFF00)>>8));
	SiSSetReg1(Part1Port,0x03,(USHORT)(((offset>>3)&0xFF)+1));
}

USHORT SiSGetOffset(ULONG ROMAddr)
{
	USHORT tempal,temp1,colordepth;
	tempal=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x03));	
	tempal=(tempal>>8)&0xFF;
	SiSScreenOffset=*((USHORT *)(ROMAddr+ScreenOffsetPtrOffset));		
	tempal=*((UCHAR *)(ROMAddr+SiSScreenOffset+tempal));		
	tempal=tempal&0xFF;
	temp1=*((UCHAR *)(ROMAddr+SiSREFIndex));	 
	if (temp1&InterlaceMode) {
		tempal=tempal<<1;
	}
	colordepth=SiSGetColorDepth(ROMAddr);
	return(tempal*colordepth); 
}

USHORT SiSGetColorDepth(ULONG ROMAddr)
{
	USHORT ColorDepth[6]={1,2,4,4,6,8};
	USHORT temp;
	int temp1;
	temp=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
	temp1=(temp&ModeInfoFlag)-ModeEGA;
	if (temp1<0) temp1=0;
	return(ColorDepth[temp1]);
}

VOID SiSSetCRT2FIFO(USHORT  Part1Port,ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{

#ifdef CONFIG_FB_SIS_315					 
	UCHAR CombCode[]={1,1,1,4,3,1,3,4,4,1,4,4,5,1,5,4};
	UCHAR CRT2ThLow[]={39,63,55,79,78,102,90,114,55,87,84,116,103,135,119,151};

	USHORT temp,temp1,temp2,temp3;
	USHORT CRT1ModeNo,CRT2ModeNo;

	SiSSetReg1(Part1Port,0x1,0x2B); 
  
	CRT1ModeNo =ModeNo;
	SiSSearchModeID(ROMAddr,CRT1ModeNo);	 
	SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
	 
	SiSGetRatePtrCRT2(ROMAddr,CRT1ModeNo);
	temp1=SiSGetVCLK(ROMAddr,CRT1ModeNo,HwDeviceExtension);
	temp2=SiSGetColorTh(ROMAddr);
	temp3=SiSGetMCLK(ROMAddr);
  
	temp=SiSGetReg1(SiSP3c4,0x14);
	if (temp&0x02)
		temp=16;
	else 
		temp=8;

	temp = temp - temp1*temp2/temp3; 

	if ((52*16 % temp)==0)
		temp = 52*16/temp +40;
	else
		temp = 52*16/temp +40 + 1;
  
	temp1=(SiSGetReg1(SiSP3c4,0x17)>>3)&0x7; 
	temp2=(SiSGetReg1(SiSP3c4,0x17)>>6)&0x3; 

	if (SiSGet310DRAMType(ROMAddr)<2) {
		for (temp3=0;temp3<16;temp3+=2) {
			if ((CombCode[temp3]==temp1) && (CombCode[temp3+1]==temp2)) {
				temp3 = CRT2ThLow[temp3>>1];
			}
		}
	} else {
		for (temp3=0;temp3<16;temp3+=2) {
			if ((CombCode[temp3]==temp1) && (CombCode[temp3+1]==temp2)) {
				temp3 = CRT2ThLow[8+(temp3>>1)];
			}
		}
	}

	temp +=  temp3; 

	CRT2ModeNo=(UCHAR)SiSGetReg1(SiSP3d4,0x34); 
	temp1=SiSGetVCLK(ROMAddr,CRT1ModeNo,HwDeviceExtension); 
	temp2=SiSGetColorTh(ROMAddr);
	temp3=SiSGetMCLK(ROMAddr);
 
	if ((temp*temp1*temp2)%(16*temp3)==0)
		temp = temp*temp1*temp2/(16*temp3); 
	else 
		temp = temp*temp1*temp2/(16*temp3)+1; 

	if (temp>0x27)
		temp = 0x27;

	SiSSetRegANDOR(Part1Port,0x02,~0x3F,temp);

#else 
	USHORT temp,temp1,temp2,temp3,flag;
	USHORT vclk2ptr,latencyindex;
	USHORT oldREFIndex,CRT1ModeNo,oldModeIDOffset;
	long int longtemp;

	USHORT LatencyFactor[48]={ 88, 80, 78, 72, 70, 00,			 
	                           00, 79, 77, 71, 69, 49,			 
	                           88, 80, 78, 72, 70, 00,			 
	                           00, 72, 70, 64, 62, 44,			 
	                           73, 65, 63, 57, 55, 00,			 
	                           00, 64, 62, 56, 54, 34,			 
	                           78, 70, 68, 62, 60, 00,			 
	                           00, 62, 60, 54, 52, 34};			 

	oldREFIndex=(USHORT)SiSREFIndex;			
	oldModeIDOffset=(USHORT)SiSModeIDOffset; 
  
	CRT1ModeNo=(UCHAR)SiSGetReg1(SiSP3d4,0x34); 
	SiSSearchModeID(ROMAddr,CRT1ModeNo);	 
	 
	SiSGetRatePtrCRT2(ROMAddr,CRT1ModeNo);
	temp1=SiSGetVCLK(ROMAddr,CRT1ModeNo,HwDeviceExtension);
	temp2=SiSGetColorTh(ROMAddr);
	temp3=SiSGetMCLK(ROMAddr);
  
	temp=((USHORT)(temp1*temp2)/temp3);	
	temp1=(UCHAR)SiSGetReg1(SiSP3c4,0x14);	
	temp1=temp1>>6;
	temp1=temp1<<1;
	if (temp1==0) temp1=1;
	temp1=temp1<<2;					

	longtemp=temp1-temp;
  
	temp2=(USHORT)((28*16)/(int)longtemp);	
	if (!((temp2*(int)longtemp)==(28*16))) temp2++;

	if ( HwDeviceExtension->jChipID == SIS_Glamour ) {		
		temp1=SiSCalcDelay();
	} else { 
		flag=(UCHAR)SiSGetReg1(SiSP3c4,0x14);	
		if (flag&0x80) {
			latencyindex=12;  
		} else {
			latencyindex=0;	
		}
		flag=SiSGetQueueConfig();
		if (!(flag&0x01)) {
			latencyindex+=24; 
		}
		if (flag&0x10) {
			latencyindex+=6;  
		}
		latencyindex=latencyindex + (flag>>5);
		temp1= LatencyFactor[latencyindex];
		temp1=temp1+15;
		flag=(UCHAR)SiSGetReg1(SiSP3c4,0x14);	
		if (!(flag&0x80)) {
			temp1=temp1+5;	 
		}
	}  
		  
	temp2=temp2+temp1;
	SiSREFIndex=oldREFIndex;			
	SiSModeIDOffset=oldModeIDOffset; 
  
	vclk2ptr=SiSGetVCLK2Ptr(ROMAddr,ModeNo,HwDeviceExtension);
  
	temp1=*((USHORT *)(ROMAddr+vclk2ptr+(SiSVCLKLen-2)));
  
	temp3=SiSGetColorTh(ROMAddr);
	longtemp=temp1*temp2*temp3;
	temp3=SiSGetMCLK(ROMAddr);
	temp3=temp3<<4;
	temp2=(int)(longtemp/temp3);
	if ((long int)temp2*(long int)temp3<(long int)longtemp) temp2++;					 

	temp1=(UCHAR)SiSGetReg1(Part1Port,0x01);			
	temp1=(temp1&(~0x1F))|0x16;
  
	if (HwDeviceExtension->jChipID >=SIS_Trojan) {
		if (HwDeviceExtension->jChipRevision >=0x30) { 
			temp1=(temp1&(~0x1F))|0x19;	
		}
	}
	SiSSetReg1(Part1Port,0x01,temp1);

	if (temp2<=6) temp2=6;
	if (temp2>0x14) temp2=0x14;
	temp1=(UCHAR)SiSGetReg1(Part1Port,0x02);			
	temp1=(temp1&(~0x1F))|temp2;
	SiSSetReg1(Part1Port,0x02,temp1);
#endif
}

USHORT SiSGetVCLK(ULONG ROMAddr,USHORT ModeNo,
		  PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempptr;
	USHORT temp1;	 
	tempptr=SiSGetVCLKPtr(ROMAddr,ModeNo,HwDeviceExtension);
  
	temp1=*((USHORT *)(ROMAddr+tempptr+(SiSVCLKLen-2)));
  
	return temp1;
}

USHORT SiSGetQueueConfig()
{
	USHORT tempal,tempbl;
	ULONG tempeax;
  
	SiSSetReg4(0xcf8,0x80000050);
	tempeax=SiSGetReg3(0xcfc);
	tempeax=(tempeax>>24)&0x0f;
	tempbl=(USHORT)tempeax;
	tempbl=tempbl<<4;
  
	SiSSetReg4(0xcf8,0x800000A0);
	tempeax=SiSGetReg3(0xcfc);
	tempeax=(tempeax>>24)&0x0f;
	tempal=(USHORT)tempeax;
	tempbl=tempbl|tempal;
  
	return(tempbl);
}

USHORT SiSGetVCLKPtr(ULONG ROMAddr,USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempal;
	tempal=(UCHAR)SiSGetReg2((USHORT)(SiSP3ca+0x02)); 
	tempal=((tempal>>2)&0x03);
	if (ModeNo>0x13) {
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));	 
		tempal=tempal&0x03F;
	}
	SiSVCLKLen=SiSGetVCLKLen(ROMAddr,HwDeviceExtension);
	tempal=tempal*SiSVCLKLen;
	if (HwDeviceExtension->jChipID==SIS_GlamourII)
		tempal=tempal+(*((USHORT *)(ROMAddr+VCLKDataPtrOffset)));  
	else
		tempal=tempal+(*((USHORT *)(ROMAddr+VCLKDataPtrOffset)));  
	return ((USHORT)tempal);
}

USHORT SiSGetColorTh(ULONG ROMAddr)
{
	USHORT temp;
	temp=SiSGetColorDepth(ROMAddr);
	temp=temp>>1;
	if (temp==0) temp++;
	return temp;
}

USHORT SiSGetMCLK(ULONG ROMAddr)
{
	USHORT tempmclkptr;
	USHORT tempmclk;
	tempmclkptr=SiSGetMCLKPtr(ROMAddr);
	tempmclk=*((USHORT *)(ROMAddr+tempmclkptr+0x03));		  
	return tempmclk;
}

USHORT SiSGetMCLKPtr(ULONG ROMAddr)
{
	USHORT tempdi;
	USHORT tempdramtype,tempax;

	tempdi=*((USHORT *)(ROMAddr+MCLKDataPtrOffset));  
  
	tempdramtype=SiSGetDRAMType(ROMAddr);
	tempax=5*tempdramtype;
	tempdi=tempdi+tempax;
	return (tempdi); 
}

USHORT SiSGetDRAMType(ULONG ROMAddr)
{
	USHORT tsoftsetting,temp3;
	tsoftsetting=*((UCHAR *)(ROMAddr+0x52));
	if (!(tsoftsetting&SoftDramType)) {
		temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x3A);
		tsoftsetting=temp3;	
	}
	tsoftsetting=tsoftsetting&0x07;
	return(tsoftsetting);
}

#if 0
static USHORT SiSCalcDelay()
{
	USHORT tempal,tempah,temp1,tempbx;
	USHORT ThTiming[8]={1,2,2,3,0,1,1,2};
	USHORT ThLowB[24]={81,4,72,6,88,8,120,12,
	                   55,4,54,6,66,8,90,12,
	                   42,4,45,6,55,8,75,12};
	
	tempah=(UCHAR)SiSGetReg1(SiSP3c4,0x18);	  
	tempah=tempah&0x62;
	tempah=tempah>>1;
	tempal=tempah;
	tempah=tempah>>3;
	tempal=tempal|tempah;
	tempal=tempal&0x07;

	temp1=ThTiming[tempal];		 

	tempbx=(UCHAR)SiSGetReg1(SiSP3c4,0x16);	  
	tempbx=tempbx>>6;
	tempah=(UCHAR)SiSGetReg1(SiSP3c4,0x14);	  
	tempah=((tempah>>4)&0x0C);
	tempbx=((tempbx|tempah)<<1);
  
	tempal=ThLowB[tempbx+1]*temp1;
	tempbx=ThLowB[tempbx];
	tempbx=tempal+tempbx;

	return(tempbx);  
}
#endif


USHORT SiSGetVCLK2Ptr(ULONG ROMAddr,USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempal;
	USHORT LCDXlat1VCLK[4]={VCLK65,VCLK65,VCLK65,VCLK65};
	USHORT LCDXlat2VCLK[4]={VCLK108_2,VCLK108_2,VCLK108_2,VCLK108_2};

	if (ModeNo<=0x13) {
		tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));		
	} else {
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));		
	}
	tempal=tempal>>6;
	if (SiSLCDResInfo!=Panel1024x768) {
		tempal=LCDXlat2VCLK[tempal];
	} else {
		tempal=LCDXlat1VCLK[tempal];
	}
  
	if (SiSVBInfo&SetCRT2ToLCD) {
		tempal=tempal;
	} else if (SiSVBInfo&SetCRT2ToTV) {
		if (SiSSetFlag&RPLLDIV2XO) {
			tempal=TVVCLKDIV2;
		} else {
			tempal=TVVCLK;
		}
	} else {
		tempal=(UCHAR)SiSGetReg2((USHORT)(SiSP3ca+0x02)); 
		tempal=((tempal>>2)&0x03);
		if (ModeNo>0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));	 
			tempal=tempal&0x03F;
		}
	}
	SiSVCLKLen=SiSGetVCLKLen(ROMAddr,HwDeviceExtension);
	tempal=tempal*SiSVCLKLen;
	if (HwDeviceExtension->jChipID==SIS_GlamourII)
		tempal=tempal+(*((USHORT *)(ROMAddr+VCLKDataPtrOffset)));  
	else
		tempal=tempal+(*((USHORT *)(ROMAddr+VCLKDataPtrOffset)));  
	return ((USHORT)tempal);
}

USHORT SiSGetVCLKLen(ULONG ROMAddr,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT VCLKDataStart,vclklabel,temp;
  
	if (HwDeviceExtension->jChipID==SIS_GlamourII)
		VCLKDataStart=*((USHORT *)(ROMAddr+VCLKDataPtrOffset));
	else
		VCLKDataStart=*((USHORT *)(ROMAddr+VCLKDataPtrOffset));

	for(temp=0;;temp++) {
		vclklabel=*((USHORT *)(ROMAddr+VCLKDataStart+temp));
		if (vclklabel==VCLKStartFreq) {
			temp=temp+2;
			return(temp);	 
		}
	}
	return(0);
}


VOID SiSSetCRT2Sync(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT temp1,tempah=0;
	USHORT temp;	
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	if (SIS_IF_DEF_LVDS==1) {  
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempah=SiSLCDInfo;
			if (!(tempah&LCDSync)) {
				temp=*((USHORT *)(ROMAddr+SiSREFIndex));	 
				tempah=(temp>>8)&0x0C0;
			} else {
				tempah=tempah&0x0C0;
			}
		}
	} else {
		temp=*((USHORT *)(ROMAddr+SiSREFIndex));	 
		tempah=(temp>>8)&0x0C0;
	}
	temp1=(UCHAR)SiSGetReg1(Part1Port,0x19);			
	temp1=(temp1&(~0x0C0))|tempah;
	SiSSetReg1(Part1Port,0x19,temp1);
}

VOID SiSGetCRT1Ptr(ULONG ROMAddr)
{
	USHORT temprefcrt1;
	USHORT temp;
	temp=*((UCHAR *)(ROMAddr+SiSREFIndex+0x02));	 
  
	temp=temp&0x03F;
  
	temp=temp*CRT1Len;
	temprefcrt1=*((USHORT *)(ROMAddr+CRT1TablePtrOffset));		
	SiSREFIndex=temprefcrt1+temp;			
}

VOID SiSSetRegAND(USHORT Port,USHORT Index,USHORT DataAND)
{
	USHORT temp1;
	temp1=SiSGetReg1(Port,Index);
	temp1= temp1&DataAND;
	SiSSetReg1(Port,Index,temp1);
}

VOID SiSSetRegOR(USHORT Port,USHORT Index,USHORT DataOR)
{
	USHORT temp1;
	temp1=SiSGetReg1(Port,Index);
	temp1= temp1|DataOR;
	SiSSetReg1(Port,Index,temp1);
}

VOID SiSSetRegANDOR(USHORT Port,USHORT Index,USHORT DataAND,USHORT DataOR)
{
	USHORT temp1;
	temp1=SiSGetReg1(Port,Index);	  
	temp1=(temp1&(DataAND))|DataOR;
	SiSSetReg1(Port,Index,temp1);
}

USHORT SiSGetVGAHT2()
{
	long int temp1,temp2;
	temp1=(SiSVGAVT-SiSVGAVDE)*SiSRVBHCMAX;
	temp1=temp1&0x0FFFF;
  
	temp2=(SiSVT-SiSVDE)*SiSRVBHCFACT;
	temp2=temp2&0x0FFFF;
	temp2=temp2*SiSHT;
	temp2=temp2/temp1;
	return((USHORT)temp2);
}

VOID SiSSetGroup2(USHORT  BaseAddr,ULONG ROMAddr)
{
	USHORT tempah,tempbl,tempbh,tempcl,i,j,tempcx,pushcx,tempbx,tempax;
	USHORT tempmodeflag,tempflowflag;
	UCHAR *temp1;
	USHORT *temp2;
	USHORT pushbx;
	USHORT  Part2Port;
	long int longtemp;
	ULONG PALPhase=0x00D3052A;
	ULONG NTSCPhase=0x088AED21;
  
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
  
	tempcx=SiSVBInfo;
	tempah=SiSVBInfo&0x0FF;
	tempbl=SiSVBInfo&0x0FF;
	tempbh=SiSVBInfo&0x0FF;
	tempbx=(tempbl&0xFF)|(tempbh<<8);
	tempbl=tempbl&0x10;
	tempbh=(tempbh&0x04)<<1;
  
	tempah=(tempah&0x08)>>1;
  
	tempah=tempah|tempbh;
	tempbl=tempbl>>3;
  
	tempah=tempah|tempbl;
	tempah=tempah^0x0C;
  
	if (SiSVBInfo&SetPALTV) {
		temp1 = (UCHAR *)&PALPhase;
		temp2= SiSPALTiming;
	} else {
		tempah=tempah|0x10;
		temp1 =(UCHAR *)&NTSCPhase;
		temp2=SiSNTSCTiming;
	} 

	SiSSetReg1(Part2Port,0x0,tempah);
	for(i=0x31;i<=0x34;i++,temp1++) {
		SiSSetReg1(Part2Port,i,*(UCHAR *)temp1);
	}
	for(i=0x01,j=0;i<=0x2D;i++,j++) {
		SiSSetReg1(Part2Port,i,temp2[j]);
	}
	for(i=0x39;i<=0x45;i++,j++) {
		SiSSetReg1(Part2Port,i,temp2[j]);	
	}

	tempah=SiSGetReg1(Part2Port,0x0A);
	tempah=tempah|SiSNewFlickerMode;
	SiSSetReg1(Part2Port,0x0A,tempah);

	SiSSetReg1(Part2Port,0x35,SiSRY1COE);
	SiSSetReg1(Part2Port,0x36,SiSRY2COE);
	SiSSetReg1(Part2Port,0x37,SiSRY3COE);
	SiSSetReg1(Part2Port,0x38,SiSRY4COE);
  
	tempcx=SiSHT-1;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x1B,tempah);
	tempah=(tempcx&0xFF00)>>8;
	SiSSetRegANDOR(Part2Port,0x1D,~0x0F,(UCHAR)tempah);

	tempcx=SiSHT>>1;
	pushcx=tempcx; 

	tempcx=tempcx+7;
  
	tempah=(tempcx&0xFF);
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x22,~0x0F0,tempah);
  
	tempbx=temp2[j];
	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x24,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x25,~0x0F0,tempah);
  
	tempbx=tempbx+8;

	tempah=((tempbx&0xFF)<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x29,~0x0F0,tempah);

	tempcx=tempcx+temp2[++j];
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x27,tempah);
	tempah=(((tempcx&0xFF00)>>8)<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x28,~0x0F0,tempah);
  
	tempcx=tempcx+8;

	tempah=tempcx&0xFF;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2A,~0x0F0,tempah);

	tempcx=pushcx;  
	tempcx=tempcx-temp2[++j];
	tempah=tempcx&0xFF;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2D,~0x0F0,tempah);

	tempcx=tempcx-11;
	if (!(SiSVBInfo&SetCRT2ToTV)) {
		tempax=SiSGetVGAHT2(); 
		tempcx=tempax-1;
	}
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x2E,tempah);

	tempbx=SiSVDE;
	if (SiSVGAVDE==360) {
		tempbx=746;
	} 
	if (SiSVGAVDE==375) {
		tempbx=746;
	}
	if (SiSVGAVDE==405) {
		tempbx=853;
	}
  
	if ((SiSVBInfo&SetCRT2ToTV)) {
		tempbx=tempbx>>1;
	}
  
	tempbx=tempbx-2;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x2F,tempah);

	tempah=(tempcx&0xFF00)>>8;
	tempbh=(tempbx&0xFF00)>>8;
	tempbh=(tempbh<<6)&0xFF;
	tempah=tempah|tempbh;
  
	tempah=tempah|0x10;
	if (!(SiSVBInfo&SetCRT2ToSVIDEO)) {
		tempah=tempah|0x20; 
	}
 
	SiSSetReg1(Part2Port,0x30,tempah);
 
	tempbh=0;
	tempbx=tempbx&0xFF;
  
	tempmodeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
	tempflowflag=0;
	if (!(tempmodeflag&HalfDCLK)) {
		tempcx=SiSVGAHDE;
		if (tempcx>=SiSHDE) {
			tempbh=tempbh|0x20;
			tempbx=(tempbh<<8)|(tempbx&0xFF);
			tempah=0;
		}
	}
  
	tempcx=0x0101;
	 
	if (!(tempbh&0x20)) {	  
		if (tempmodeflag&HalfDCLK) {
			tempcl=((tempcx&0xFF)<<1)&0xFF;
			tempcx=(tempcx&0xFF00)|tempcl; 
		}
		pushbx=tempbx;
		tempax=SiSVGAHDE;
		tempbx=(tempcx&0xFF00)>>8;
		longtemp=tempax*tempbx;
		tempcx=tempcx&0xFF;
		longtemp=longtemp/tempcx;
		longtemp=longtemp*8*1024;
		tempax=(USHORT)((longtemp)/SiSHDE);
		if (tempax*SiSHDE<longtemp) {
			tempax=tempax+1;
		} else {
			tempax=tempax;
		}
		tempbx=pushbx;
		tempah=((tempax&0xFF00)>>8)&0x01F;
		tempbh=tempbh|tempah;
		tempah=tempax&0xFF;
	}

	SiSSetReg1(Part2Port,0x44,tempah);
	tempah=tempbh;
	SiSSetRegANDOR(Part2Port,0x45,~0x03F,tempah);
  
	if (SiSVBInfo&SetCRT2ToTV) {
		return;
	}
  
	tempah=0x01;
	if (SiSLCDResInfo==Panel1280x1024) {
		if (SiSModeType==ModeEGA) {		
			if (SiSVGAHDE>=1024) {
				tempah=0x02; 
			}
		}
	} 
	SiSSetReg1(Part2Port,0x0B,tempah);
  
	tempbx=SiSHDE-1;			
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x2C,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2B,~0x0F0,tempah);
  
	tempbx=SiSVDE-1;			
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x03,tempah);
	tempah=((tempbx&0xFF00)>>8)&0x07;
	SiSSetRegANDOR(Part2Port,0x0C,~0x07,tempah);

	tempcx=SiSVT-1;
	tempah=tempcx&0xFF;	
	SiSSetReg1(Part2Port,0x19,tempah);
	tempah=(tempcx&0xFF00)>>8;
	tempah=(tempah<<5)&0xFF;
	if (SiSLCDInfo&LCDRGB18Bit) {
		tempah=tempah|0x10;
	}
	SiSSetReg1(Part2Port,0x1A,tempah);
  
	tempcx++;
	if (SiSLCDResInfo==Panel1024x768) {
		tempbx=768;
	} else {
		tempbx=1024;
	}
  
	if (tempbx==SiSVDE) {
		tempax=1;
	} else {
		tempax=tempbx;
		tempax=(tempax-SiSVDE)>>1;
	}
	tempcx=tempcx-tempax; 
	tempbx=tempbx-tempax; 

	tempah=tempcx&0xFF;	
	SiSSetReg1(Part2Port,0x05,tempah);
	tempah=tempbx&0xFF;	
	SiSSetReg1(Part2Port,0x06,tempah);

	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<3)&0xFF;
	tempah=tempah|((tempcx&0xFF00)>>8); 
		  
	SiSSetReg1(Part2Port,0x02,tempah);
 
	tempcx=(SiSVT-SiSVDE)>>4;	
	tempbx=(SiSVT+SiSVDE)>>1;
	tempah=tempbx&0xFF;	
	SiSSetReg1(Part2Port,0x04,tempah);

	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	tempbx=tempbx+tempcx+1;
	tempbl=(tempbx&0x0F);
	tempah=tempah|tempbl;  
	SiSSetReg1(Part2Port,0x01,tempah);
 
	tempah=SiSGetReg1(Part2Port,0x09);
	tempah=tempah&0xF0;
	SiSSetReg1(Part2Port,0x09,tempah);

	tempah=SiSGetReg1(Part2Port,0x0A);
	tempah=tempah&0xF0;
	SiSSetReg1(Part2Port,0x0A,tempah);

	tempcx=(SiSHT-SiSHDE)>>2;	 
	tempbx=(SiSHDE+7);		  
	tempah=tempbx&0xFF;	 
	SiSSetReg1(Part2Port,0x23,tempah);
	tempah=(tempbx&0xFF00)>>8;
	SiSSetRegANDOR(Part2Port,0x25,~0x0F,tempah);

	SiSSetReg1(Part2Port,0x1F,0x07);  
	tempah=SiSGetReg1(Part2Port,0x20);
	tempah=tempah&0x0F;
	SiSSetReg1(Part2Port,0x20,tempah);

	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;				
	SiSSetReg1(Part2Port,0x1C,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF; 
	SiSSetRegANDOR(Part2Port,0x1D,~0x0F0,tempah);
 
	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;				
	SiSSetReg1(Part2Port,0x21,tempah);

	tempah=SiSGetReg1(Part2Port,0x17);
	tempah=tempah&0xFB;
	SiSSetReg1(Part2Port,0x17,tempah);

	tempah=SiSGetReg1(Part2Port,0x18);
	tempah=tempah&0xDF;
	SiSSetReg1(Part2Port,0x18,tempah);
	return;
}

VOID SiSSetGroup3(USHORT  BaseAddr)
{
	USHORT i;
	USHORT *tempdi;
	USHORT  Part3Port;
	Part3Port=BaseAddr+IND_SIS_CRT2_PORT_12;
  
	if (SiSVBInfo&SetPALTV) {
		tempdi=SiSPALGroup3Data;					
	} else {
		tempdi=SiSNTSCGroup3Data;
	}

	for(i=0;i<=0x3E;i++) {
		SiSSetReg1(Part3Port,i,tempdi[i]);
	}
	return;
}

VOID SiSSetGroup4(USHORT  BaseAddr,ULONG ROMAddr,USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT  Part4Port;
	USHORT tempax,tempah,tempcx,tempbx,tempbh,tempch,tempmodeflag;
	long int tempebx,tempeax,templong;  
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;

	tempax=0x0c;
	if (SiSVBInfo&SetCRT2ToTV) {
		if (SiSVBInfo&SetInSlaveMode) {
			if (!(SiSSetFlag&TVSimuMode)) {
				SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
				tempax=tempax|0x04000;	
			}
		} else {
			SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
			tempax=tempax|0x04000;	 
		}
	}

	if (SiSLCDResInfo!=Panel1024x768) {
		tempax=tempax|0x08000;
	}
	tempah=(tempax&0xFF00)>>8;
	SiSSetReg1(Part4Port,0x0C,tempah);
  
	tempah=SiSRVBHCFACT;
	SiSSetReg1(Part4Port,0x13,tempah);
  
	tempbx=SiSRVBHCMAX;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part4Port,0x14,tempah);
	tempbh=(((tempbx&0xFF00)>>8)<<7)&0xFF;

	tempcx=SiSVGAHT-1;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x16,tempah);
	tempch=(((tempcx&0xFF00)>>8)<<3)&0xFF;
	tempbh=tempbh|tempch;
  
	tempcx=SiSVGAVT-1;
	if (!(SiSVBInfo&SetCRT2ToTV)) {
		tempcx=tempcx-5;
	}
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x17,tempah);
	tempbh=tempbh|((tempcx&0xFF00)>>8);
	tempah=tempbh;
	SiSSetReg1(Part4Port,0x15,tempah);
  
	tempcx=SiSVBInfo;
	tempbx=SiSVGAHDE;
	tempmodeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
	if (tempmodeflag&HalfDCLK) {
		tempbx=tempbx>>1;			  
	}
 
	if (SiSVBInfo&SetCRT2ToLCD) {
		tempah=0;
		if (tempbx>800) {
			tempah=0x60; 
		}
	} else {
		tempah=0x080;
	}
	if (SiSLCDResInfo!=Panel1280x1024) {
		tempah=tempah|0x0A;
	}

	SiSSetRegANDOR(Part4Port,0x0E,~0xEF,tempah);

	tempebx=SiSVDE;

	tempcx=SiSRVBHRS;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x18,tempah);

	tempeax=SiSVGAVDE;
	tempcx=tempcx|0x04000;
	tempeax=tempeax-tempebx;
	if (tempeax<0) {
		tempcx=tempcx^(0x04000);
		tempeax=SiSVGAVDE;
	}

	templong=(tempeax*256*1024)/tempebx;
	if (tempeax*256*1024-templong*tempebx>0) {
		tempebx=templong+1;
	} else {
		tempebx=templong;
	} 

	tempah=(USHORT)(tempebx&0xFF);
	SiSSetReg1(Part4Port,0x1B,tempah);
	tempah=(USHORT)((tempebx&0xFF00)>>8);
	SiSSetReg1(Part4Port,0x1A,tempah);
	tempebx=tempebx>>16;
	tempah=(USHORT)(tempebx&0xFF);
	tempah=(tempah<<4)&0xFF;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part4Port,0x19,tempah);
  
	SiSSetCRT2VCLK(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
}

VOID SiSSetCRT2VCLK(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT vclk2ptr;
	USHORT tempah,temp1;
	USHORT  Part4Port;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;

	vclk2ptr=SiSGetVCLK2Ptr(ROMAddr,ModeNo,HwDeviceExtension);
	SiSSetReg1(Part4Port,0x0A,0x01);
	tempah=*((UCHAR *)(ROMAddr+vclk2ptr+0x01));	
	SiSSetReg1(Part4Port,0x0B,tempah);
	tempah=*((UCHAR *)(ROMAddr+vclk2ptr+0x00));	
	SiSSetReg1(Part4Port,0x0A,tempah);
	SiSSetReg1(Part4Port,0x12,0x00);
	tempah=0x08;
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempah=tempah|0x020;
	}
	temp1=SiSGetReg1(Part4Port,0x12);
	tempah=tempah|temp1;
	SiSSetReg1(Part4Port,0x12,tempah);
}

VOID SiSSetGroup5(USHORT  BaseAddr,ULONG ROMAddr)
{
	USHORT  Part5Port;
	USHORT Pindex,Pdata;
	Part5Port=BaseAddr+IND_SIS_CRT2_PORT_14+2;
  
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	if (SiSModeType==ModeVGA) {
		if (!(SiSVBInfo&(SetInSlaveMode|LoadDACFlag|CRT2DisplayFlag))) {
			SiSEnableCRT2();
			SiSLoadDAC2(ROMAddr,Part5Port);
		}
	}
	return;
}

VOID SiSEnableCRT2()
{
	USHORT temp1;
	temp1=SiSGetReg1(SiSP3c4,0x1E);
	temp1=temp1|0x20;
	SiSSetReg1(SiSP3c4,0x1E,temp1);	  
}

VOID SiSLoadDAC2(ULONG ROMAddr,USHORT Part5Port)
{
	USHORT data,data2;
	USHORT time,i,j,k;
	USHORT m,n,o;
	USHORT si,di,bx,dl;
	USHORT al,ah,dh;
	USHORT *table=SIS_VGA_DAC;
	USHORT Pindex,Pdata;
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	data=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	data=data&DACInfoFlag;
	time=64;
	if (data==0x00) table=SIS_MDA_DAC;
	if (data==0x08) table=SIS_CGA_DAC;
	if (data==0x10) table=SIS_EGA_DAC;
	if (data==0x18) {
		time=256;
		table=SIS_VGA_DAC;
	}
	if (time==256) j=16;
	else j=time;
	
	SiSSetReg3(Pindex,0x00);

	for(i=0;i<j;i++) {
		data=table[i];
		for(k=0;k<3;k++) {
			data2=0;
			if (data&0x01) data2=0x2A;
			if (data&0x02) data2=data2+0x15;
			SiSSetReg3(Pdata,(USHORT)(data2));
		  
			data=data>>2;
		}
	}

	if (time==256) {
		for(i=16;i<32;i++) {
			data=table[i];
			for(k=0;k<3;k++) SiSSetReg3(Pdata,(USHORT)(data));
		}
		si=32;
		for(m=0;m<9;m++) {
			di=si;
			bx=si+0x04;
			dl=0;
			for(n=0;n<3;n++) {
				for(o=0;o<5;o++) {
					dh=table[si];
					ah=table[di];
					al=table[bx];
					si++;
					SiSWriteDAC2(Pdata,dl,ah,al,dh);
				}			
				si=si-2;
				for(o=0;o<3;o++) {
					dh=table[bx];
					ah=table[di];
					al=table[si];
					si--;
					SiSWriteDAC2(Pdata,dl,ah,al,dh);
				}			
				dl++;
			}				
			si=si+5;
		}					
	}
}

VOID SiSWriteDAC2(USHORT Pdata,USHORT dl, USHORT ah, USHORT al, USHORT dh)
{
	USHORT temp;
	USHORT bh,bl;

	bh=ah;
	bl=al;
	if (dl!=0) {
		temp=bh;
		bh=dh;
		dh=temp;
		if (dl==1) {
			temp=bl;
			bl=dh;
			dh=temp;
		} else {
			temp=bl;
			bl=bh;
			bh=temp;
		}
	}
	SiSSetReg3(Pdata,(USHORT)(dh));
	SiSSetReg3(Pdata,(USHORT)(bh));
	SiSSetReg3(Pdata,(USHORT)(bl));
}

VOID SiSLockCRT2(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr)
{
	USHORT  Part1Port;
	USHORT  Part4Port;
	USHORT temp1;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	if (HwDeviceExtension->jChipID == SIS_GlamourII) {
		temp1=SiSGetReg1(Part1Port,0x2F);
		temp1=temp1&0xFE;
		SiSSetReg1(Part1Port,0x2F,temp1);
	}
	else if (HwDeviceExtension->jChipID == SIS_Glamour) {
		temp1=SiSGetReg1(Part1Port,0x24);
		temp1=temp1&0xFE;
		SiSSetReg1(Part1Port,0x24,temp1);
	}
}

VOID SiSSetLockRegs()
{
	USHORT temp1;
  
	if ((SiSVBInfo&SetInSlaveMode)&&(!(SiSVBInfo&SetCRT2ToRAMDAC))) {
		SiSVBLongWait();
		temp1=SiSGetReg1(SiSP3c4,0x32);
		temp1=temp1|0x20;
		SiSSetReg1(SiSP3c4,0x32,temp1);
		SiSVBLongWait();
	}
}

VOID SiSEnableBridge(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr)
{
	USHORT part2_02,part2_05;
	USHORT  Part2Port,Part1Port;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;

	if (SIS_IF_DEF_LVDS==0) {
		SiSSetRegOR(Part1Port,0x2E,0x80);		 
		part2_02=(UCHAR)SiSGetReg1(Part2Port,0x02);
		part2_05=(UCHAR)SiSGetReg1(Part2Port,0x05);
		SiSSetReg1(Part2Port,0x02,0x38);
		SiSSetReg1(Part2Port,0x05,0xFF);
		SiSLongWait();
		SiSSetRegANDOR(Part2Port,0x00,~0x0E0,0x020);
		SiSWaitVBRetrace(HwDeviceExtension,BaseAddr);
		SiSSetReg1(Part2Port,0x02,part2_02);
		SiSSetReg1(Part2Port,0x05,part2_05);
		SiSSetRegAND(Part1Port,0x00,0x7F);		 
	} else {
		SiSEnableCRT2();
		SiSUnLockCRT2(HwDeviceExtension,BaseAddr);
		SiSSetRegANDOR(Part1Port,0x02,~0x040,0x0);
	}
}

USHORT SiSGetLockInfo(USHORT pattern)
{
	USHORT temp1;

	temp1=SiSGetReg1(SiSP3d4,0x36);
	return(temp1&pattern);
}	

BOOLEAN SiSBridgeIsOn(USHORT BaseAddr)
{
	USHORT Part4Port;
	USHORT flag1;
  
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	flag1=SiSGetReg1(Part4Port,0);
	if ((flag1!=1)&&(flag1!=2)&&(flag1!=3))
		return FALSE;
	else
		return (BOOLEAN)flag1;
}

VOID SiSGetVBInfo301(USHORT BaseAddr,ULONG ROMAddr)
{
	USHORT flag1,tempbx,tempbl,tempbh,tempah;
  
	SiSSetFlag=0;
	tempbx=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
	tempbl=tempbx&ModeInfoFlag;
	SiSModeType=tempbl;
	tempbx=0;
  
	if (!SiSBridgeIsOn(BaseAddr)) {
		SiSVBInfo=CRT2DisplayFlag;
		return;
	}
	tempbl=SiSGetReg1(SiSP3d4,0x30);  
	tempbh=SiSGetReg1(SiSP3d4,0x31);
  
	if (!(tempbl&0x07C)) {
		SiSVBInfo=CRT2DisplayFlag;
		return;
	}
	if (SIS_IF_DEF_LVDS==1) {  
		if (!(tempbl&SetCRT2ToLCD)) {
			SiSVBInfo=CRT2DisplayFlag;
			return;
		}
	}
	if (SIS_IF_DEF_LVDS==0) { 
		if (tempbl&SetCRT2ToRAMDAC) {
			tempbl=tempbl&(SetCRT2ToRAMDAC|SwitchToCRT2|SetSimuScanMode);
		} else if (tempbl&SetCRT2ToLCD) {
			tempbl=tempbl&(SetCRT2ToLCD|SwitchToCRT2|SetSimuScanMode);
		} else if (tempbl&SetCRT2ToSCART) {
			tempbl=tempbl&(SetCRT2ToSCART|SwitchToCRT2|SetSimuScanMode);
		} else if (tempbl&SetCRT2ToHiVisionTV) {
			tempbl=tempbl&(SetCRT2ToHiVisionTV|SwitchToCRT2|SetSimuScanMode);
		}
	} else { 
		if (tempbl&SetCRT2ToLCD) {
			tempbl=tempbl&(SetCRT2ToLCD|SwitchToCRT2|SetSimuScanMode);
		}
	}
	tempah=SiSGetReg1(SiSP3d4,0x31);
	if (tempah&(CRT2DisplayFlag>>8)) {
		if (!(tempbl&(SwitchToCRT2|SetSimuScanMode))) {
			tempbx=SetSimuScanMode|CRT2DisplayFlag;
			tempbh=((tempbx&0xFF00)>>8);
			tempbl=tempbx&0xFF;
		}
	}
	if (!(tempbh&(DriverMode>>8))) {
		tempbl=tempbl|SetSimuScanMode;
	}
	SiSVBInfo=tempbl|(tempbh<<8);
	if (!(SiSVBInfo&SetSimuScanMode)) {
		if (!(SiSVBInfo&SwitchToCRT2)) {
			if (SiSBridgeIsEnable(BaseAddr)) {
				if (SiSBridgeInSlave()) {
					SiSVBInfo=SiSVBInfo|SetSimuScanMode;
				}  
			}
		}
	}	 
	if (!((SiSVBInfo&(SetSimuScanMode|SwitchToCRT2)))) {
		return;
	}
	if (!(SiSVBInfo&DriverMode)) {
		SiSVBInfo=SiSVBInfo|SetInSlaveMode;
		if ((SiSVBInfo&SetCRT2ToTV)&&(!(SiSVBInfo&SetNotSimuTVMode))) {
			SiSSetFlag=SiSSetFlag|TVSimuMode;
		}
		return;
	}
	flag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
	if (!(flag1&(CRT2Mode|CRT2DisplayFlag))) {
		SiSVBInfo=SiSVBInfo|SetInSlaveMode;
		if ((SiSVBInfo&SetCRT2ToTV)&&(!(SiSVBInfo&SetNotSimuTVMode))) {
			SiSSetFlag=SiSSetFlag|TVSimuMode;
		}
	}
}

BOOLEAN SiSBridgeIsEnable(USHORT BaseAddr)
{
	USHORT flag1;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;

	if (SIS_IF_DEF_LVDS==1) {
		return 1;
	}
	if (!SiSBridgeIsOn(BaseAddr))
		return 0;
  
	flag1=SiSGetReg1(Part1Port,0x0);
	if (flag1&0x0a0) {
		return 1;
	} else {
		return 0;
	}
}

BOOLEAN SiSBridgeInSlave()
{
	USHORT flag1;
	flag1=SiSGetReg1(SiSP3d4,0x31);
	if (flag1&(SetInSlaveMode>>8)) {
		return 1;
	} else {
		return 0;
	}
}

BOOLEAN SiSGetLCDResInfo301(ULONG ROMAddr,USHORT SiSP3d4)
{
	USHORT tempah,tempbh,tempflag;		  
  
	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x36);
	tempbh=tempah;
	tempah=tempah&0x0F;
  
	if (tempah>Panel1280x1024) tempah=Panel1024x768;
	SiSLCDResInfo=tempah;
	tempbh=tempbh>>4;
	SiSLCDTypeInfo=tempbh;
  
	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x37);
	SiSLCDInfo=tempah;
	if (SIS_IF_DEF_TRUMPION) {
		SiSLCDInfo=SiSLCDInfo&(~LCDNonExpanding);
	}
	if (SIS_IF_DEF_LVDS==1) {
		tempflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));		
		if (tempflag&HalfDCLK) {
			if (SIS_IF_DEF_TRUMPION==0) {
				if (!(SiSLCDInfo&LCDNonExpanding)) {
					if (SiSLCDResInfo==Panel1024x768) {
						tempflag=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x0a)); 
						if (tempflag==4) { 
							SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
						}
					} else {
						if (SiSLCDResInfo==Panel800x600) {
							tempflag=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x0a)); 
							if (tempflag==3) { 
								SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
							} 
						}
					}
				} else {
					SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
				}
			} else {
				SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
			}
		}
	}
	
	if (!(SiSVBInfo&SetCRT2ToLCD)) {
		return 1;			  
	}
	if (!(SiSVBInfo&(SetSimuScanMode|SwitchToCRT2))) {
		return 1;	
	}
	if (SiSVBInfo&SetInSlaveMode) {
		if (SiSVBInfo&SetNotSimuTVMode) {
			SiSSetFlag=SiSSetFlag|LCDVESATiming;	 
		}	
	} else {
		SiSSetFlag=SiSSetFlag|LCDVESATiming;		
	}
	return 1;	  
}

VOID SiSPresetScratchregister301(USHORT SiSP3d4,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	SiSSetReg1(SiSP3d4,0x37,0x00);		
}

BOOLEAN SiSGetLCDDDCInfo301(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempah=0;
  
										  
	tempah=(HwDeviceExtension->usLCDType);
	if (tempah>0) tempah++; 
								
	SiSSetReg1(SiSP3d4,0x36,tempah);
	if (tempah>0) return 1;
	else return 0;		  
}

VOID SiSSetTVSystem301(PHW_DEVICE_EXTENSION HwDeviceExtension,ULONG ROMAddr)
{
	USHORT tempah,temp;
	if (SIS_IF_DEF_LVDS==0) { 
		if (PRIMARY_VGA==1) { 
			if (HwDeviceExtension->jChipID >= SIS_Trojan) {
				tempah=SiSGetReg1(SiSP3c4,0x17);
				if (tempah&ModeSwitchStatus) {
					tempah=SiSGetReg1(SiSP3c4,0x16);
					tempah=tempah&ActivePAL;
					tempah=tempah>>ActivePALShift;
				} else {
					temp=*((UCHAR *)(ROMAddr+SoftSettingAddr));
					if (temp&SoftTVType) {
						tempah=*((UCHAR *)(ROMAddr+ModeSettingAddr));
					} else {
						tempah=SiSGetReg1(SiSP3c4,0x38);  
					}
				}
			} else {
				temp=*((UCHAR *)(ROMAddr+SoftSettingAddr));
				if (temp&SoftTVType) {
					tempah=*((UCHAR *)(ROMAddr+ModeSettingAddr));
				} else {
					tempah=SiSGetReg1(SiSP3c4,0x38);  
				}
			}
			tempah=tempah&0x01;					  
													  
			SiSSetRegANDOR(SiSP3d4,0x31,~0x01,tempah);
		}
		else { 
			tempah=SiSGetReg1(SiSP3c4,0x38);  
			tempah=tempah&0x01;					  
													  
			SiSSetRegANDOR(SiSP3d4,0x31,~0x01,tempah);
		}
		return;
	} else { 
		tempah=SiSGetReg1(SiSP3c4,0x16);  
		tempah=tempah&ActiveNonExpanding;
		tempah=tempah>>ActiveNonExpandingShift;
		tempah=tempah&0x01;  
		tempah=tempah<<LCDNonExpandingShift;
		SiSSetRegANDOR(SiSP3d4,0x37,~LCDNonExpanding,tempah);
		return;
	}	  
}
BOOLEAN SiSGetSenseStatus301(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr)
{
	USHORT flag1,tempbx,tempal,tempah,tempcx,i;	 
	USHORT Part2Port,Part4Port;
	USHORT RGBSenseData,YCSenseData,VideoSenseData;
	USHORT P2reg0,SenseModeNo,OutputSelect;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
  
	RGBSenseData=*((USHORT *)(ROMAddr+RGBSenseDataOffset)); 
	YCSenseData=*((USHORT *)(ROMAddr+YCSenseDataOffset)); 
	VideoSenseData=*((USHORT *)(ROMAddr+VideoSenseDataOffset)); 

	if (SIS_IF_DEF_LVDS==1) {
		SiSGetPanelID();
		tempah=LCDSense;
		SiSSetRegANDOR(SiSP3d4,0x32,~0x5F,tempah); 
		return 0;
	}
	 
	if (!SiSBridgeIsOn(BaseAddr))
		return 0;
  
	P2reg0=SiSGetReg1(Part2Port,0x00); 
  
	if (!(SiSBridgeIsEnable(BaseAddr))) {
		SenseModeNo=0x2E;
		 
		SiSModeType=ModeVGA;
		SiSVBInfo=SetCRT2ToRAMDAC;
		SiSSetFlag=0;
		SiSSetCRT2Group301(BaseAddr,ROMAddr,SenseModeNo,HwDeviceExtension);
		 
		for(i=0;i<0x7FFF;i++) {
			flag1=SiSGetReg1(SiSP3c4,0x05);		  
		}
	}	  
  
	SiSSetReg1(Part2Port,0x00,0x1C);  
	tempah=0;
  
	OutputSelect=*((UCHAR *)(ROMAddr+OutputSelectOffset));  

	if (OutputSelect&SetSCARTOutput) {
		tempal=SCARTSense;  
	} else {
		tempal=Monitor2Sense;
	}
	tempbx=RGBSenseData;
	tempcx=0x0E08;
	if (SiSSense(Part4Port,tempbx,tempcx)) {
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			tempah=tempah|tempal; 
		}		
	}
	tempbx=YCSenseData;
	tempcx=0x0604;
	if (SiSSense(Part4Port,tempbx,tempcx)) {
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			tempah=tempah|SVIDEOSense;
		}
	}
  
	if (OutputSelect&BoardTVType) {
		tempbx=VideoSenseData;
		tempcx=0x0804;
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			if (SiSSense(Part4Port,tempbx,tempcx)) {
				tempah=tempah|AVIDEOSense;
			}		  
		}	
	} else {
		if (!(tempah&SVIDEOSense)) {
			tempbx=VideoSenseData;
			tempcx=0x0804;
			if (SiSSense(Part4Port,tempbx,tempcx)) {
				if (SiSSense(Part4Port,tempbx,tempcx)) {
					tempah=tempah|AVIDEOSense; 
				}	  
			} 
		}
	}

	if (SiSSenseLCD(HwDeviceExtension,Part4Port,ROMAddr)) {
		if (SiSSenseLCD(HwDeviceExtension,Part4Port,ROMAddr)) {
			tempah=tempah|LCDSense;
		}	  
	}
  
	tempbx=0; 
	tempcx=0;
	SiSSense(Part4Port,tempbx,tempcx);
  
	SiSSetRegANDOR(SiSP3d4,0x32,~0x5F,tempah); 
	SiSSetReg1(Part2Port,0x00,P2reg0);		
  
	return 0;  
}

BOOLEAN SiSSense(USHORT Part4Port,USHORT inputbx,USHORT inputcx)
{
	USHORT tempah,tempcl,tempch;
  
	tempah=inputbx&0xFF;
	SiSSetReg1(Part4Port,0x11,tempah);
	tempah=(inputbx&0xFF00)>>8;
	tempcl=inputcx&0xFF;
	tempah=tempah|tempcl;
	SiSSetRegANDOR(Part4Port,0x10,~0x1F,tempah);
  
	tempch=(inputcx&0xFF00)>>8;
	tempch=tempch&0x7F;
  
	tempah=SiSGetReg1(Part4Port,0x03);					
	tempah=tempah^(0x0E);
	tempah=tempah&tempch;
	if (tempah>0) return 1;
	else return 0;		  
}

BOOLEAN SiSSenseLCD(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT Part4Port,ULONG ROMAddr)
{
	USHORT SoftSetting;
	USHORT tempah;		  
  
	SoftSetting=*((UCHAR *)(ROMAddr+SoftSetting_OFFSET));
	if (SiSGetLCDDDCInfo301(HwDeviceExtension)) {
		return 1;	
	}
	if (SoftSetting&HotPlugFunction) {
		tempah=SiSGetReg1(Part4Port,0x0F);
		tempah=tempah&0x3F;
		SiSSetReg1(Part4Port,0x0F,tempah); 
		if (SiSSense(Part4Port,0x0,0x9010)) {
			return 1; 
		} else {
			return 0;
		}	
	} else {
		return 0;
	}	  
}

BOOLEAN SiSDetectMonitor301(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT flag1;
	USHORT DAC_TEST_PARMS[3]={0x0F,0x0F,0x0F};
	USHORT DAC_CLR_PARMS[3]={0x00,0x00,0x00};
  
	if (SiSBridgeIsOn( (USHORT) HwDeviceExtension->IOAddress))
		SiSSetReg1(SiSP3d4,0x30,0x41);

	SiSSetMode310(HwDeviceExtension,0x2E);
 
	SiSClearDAC(SiSP3c8);
	SiSClearALLBuffer(HwDeviceExtension);
  
	SiSLongWait();	
	SiSLongWait();
  
	flag1=SiSTestMonitorType(DAC_TEST_PARMS[0],DAC_TEST_PARMS[1],
	DAC_TEST_PARMS[2]);
	if (flag1==0) {
		flag1=SiSTestMonitorType(DAC_TEST_PARMS[0],DAC_TEST_PARMS[1],
		DAC_TEST_PARMS[2]);	  
	}	  
	if (flag1==1) {
		SiSSetRegANDOR(SiSP3d4,0x32,~Monitor1Sense,Monitor1Sense);					 
	} else {
		SiSSetRegANDOR(SiSP3d4,0x32,~Monitor1Sense,0x0);
	}
	SiSTestMonitorType(DAC_CLR_PARMS[0],DAC_CLR_PARMS[1], DAC_CLR_PARMS[2]);
		  
	SiSSetReg1(SiSP3d4,0x34,0x4A);
								  
	return 1;	  
}

#if 0
VOID SiSClearALLBuffer(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	PVOID	VideoMemoryAddress = (PVOID)HwDeviceExtension->pjVideoMemoryAddress;
	ULONG	AdapterMemorySize;

	AdapterMemorySize=SiSGetReg1(SiSP3c4,0x14); 
	AdapterMemorySize=AdapterMemorySize&0x3F;
	AdapterMemorySize++;  
	VideoPortZeroMemory(VideoMemoryAddress, AdapterMemorySize*1024*1024);
}
#endif

BOOLEAN SiSTestMonitorType(USHORT d1,USHORT d2,USHORT d3)
{
	USHORT temp;  
	SiSSetReg3(SiSP3c6,0xFF);
	SiSSetReg3(SiSP3c8,0x00);
	SiSSetReg3(SiSP3c9,d1);
	SiSSetReg3(SiSP3c9,d2);
	SiSSetReg3(SiSP3c9,d3);
	SiSWaitDisplay();		  
	temp=SiSGetReg2(SiSP3c2);
	if (temp&0x10) return 1;
	else return 0;		  
}

VOID SiSWaitDisplay()
{
	USHORT temp;
 
	for(temp=0;temp==0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x01;	 
	}
	for(;temp==1;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x01;	 
	}	  
}

VOID SiSLongWait()
{
	USHORT temp,temp1;
  
	for(temp=1;temp>0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;	 
	}
	for(temp1=0;temp1<0xffff;temp1++) {	
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;	 
		if (temp!=0)	
		break;
	}	  
}

VOID SiSVBLongWait()
{
	USHORT regsr1f,tempah,temp;
	
	regsr1f=SiSGetReg1(SiSP3c4,0x1F);
	tempah=regsr1f&(~0xC0);
	SiSSetReg1(SiSP3c4,0x1F,tempah);

	for(temp=1;temp>0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;	 
	}
	for(;temp==0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;	 
	}

	SiSSetReg1(SiSP3c4,0x1F,regsr1f);
	return;	
}

BOOLEAN SiSWaitVBRetrace(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT  BaseAddr)
{
	USHORT temp;
	USHORT Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
  
	switch (HwDeviceExtension->jChipID) {
	case SIS_Glamour:
		temp=SiSGetReg1(Part1Port,0x00);
		if (!(temp&0x80)) {
			return 0;
		}

		for(temp=0;temp==0;) {
			temp=SiSGetReg1(Part1Port,0x25);
			temp=temp&0x01;	 
		}
		for(;temp>0;) {
			temp=SiSGetReg1(Part1Port,0x25);
			temp=temp&0x01;	 
		}
		break;
	case SIS_GlamourII:
		temp=SiSGetReg1(Part1Port,0x00);
		if (!(temp&0x40)) {
			return 0;
		}

		for(temp=0;temp==0;) {
			temp=SiSGetReg1(Part1Port,0x30);
			temp=temp&0x01;
		}
		for(;temp>0;) {
			temp=SiSGetReg1(Part1Port,0x30);
			temp=temp&0x01;
		}
		break;
	case SIS_Trojan:
	case SIS_Spartan:
	case SIS_730:
	case SIS_315:
	case SIS_UNKNOWN:
	case SIS_550:
	case MAX_SIS_CHIP:
		break;
	}
  return 1; 
}

BOOLEAN SiSGetPanelID()
{
	USHORT PanelTypeTable[16]={ SyncPP|Panel800x600|PanelType00,
	                            SyncPP|Panel1024x768|PanelType01,
	                            SyncPP|Panel1024x768|PanelType02,
	                            SyncPP|Panel1024x768|PanelType03,
	                            SyncPP|Panel1024x768|PanelType04,
	                            SyncPP|Panel1024x768|PanelType05,
	                            SyncPP|Panel1024x768|PanelType06,
	                            SyncPP|Panel1024x768|PanelType07,
	                            SyncPP|Panel1024x768|PanelType08,
	                            SyncPP|Panel1024x768|PanelType09,
	                            SyncPP|Panel800x600|PanelType0A,
	                            SyncPP|Panel1024x768|PanelType0B,
	                            SyncPP|Panel1024x768|PanelType0C,
	                            SyncPP|Panel1024x768|PanelType0D,
	                            SyncPP|Panel1024x768|PanelType0E,
	                            SyncPP|Panel1024x768|PanelType0F};
  
	USHORT tempah,tempbx;
	USHORT return_flag;

	tempah=SiSGetReg1(SiSP3c4,0x18);
	tempbx=tempah&0x0F;
	if (tempah&0x10) {
		return_flag=1;
	} else {
		return_flag=0;
	}
	
	if (return_flag==0) {
		if (SIS_IF_DEF_LVDS==1) {
			tempbx=0;
			tempah=SiSGetReg1(SiSP3c4,0x38);
			if (tempah&0x40) tempbx=tempbx|0x08;
			if (tempah&0x20) tempbx=tempbx|0x02;
			if (tempah&0x01) tempbx=tempbx|0x01;
			tempah=SiSGetReg1(SiSP3c4,0x39);
			if (tempah&0x80) tempbx=tempbx|0x04;
		} else {
			return 0;
		}
	}
	
	if (SIS_IF_DEF_TRUMPION==1) {
		tempbx=1;
	}
	tempbx=PanelTypeTable[tempbx]; 
	tempbx=tempbx|(USHORT)(LCDSync<<8);
	
	tempah=tempbx&0x0FF;
	SiSSetReg1(SiSP3d4,0x36,tempah);
	tempah=(tempbx&0xFF00)>>8;
	SiSSetRegANDOR(SiSP3d4,0x37,~LCDSyncBit,tempah);
	return 1;
}

VOID SiSModCRT1CRTC(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT OldREFIndex,temp,tempah,i,modeflag1;

	OldREFIndex=(USHORT)SiSREFIndex;
	temp=SiSGetLVDSCRT1Ptr(ROMAddr,ModeNo);
	if (temp==0) {
		SiSREFIndex=OldREFIndex;
		return;
	}
	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x11);
	tempah=tempah&0x7F;
	SiSSetReg1(SiSP3d4,0x11,tempah);
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	SiSSetReg1(SiSP3d4,0x0,tempah);
	SiSREFIndex++;
	for(i=0x02;i<=0x05;SiSREFIndex++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x06;i<=0x07;SiSREFIndex++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x10;i<=0x11;SiSREFIndex++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x15;i<=0x16;SiSREFIndex++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}

	for(i=0x0A;i<=0x0C;SiSREFIndex++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3c4,i,tempah); 
	}
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=tempah&0x0E0;
	SiSSetReg1(SiSP3c4,0x0E,tempah);
	
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=tempah&0x01;
	tempah=tempah<<5;
	modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (modeflag1&DoubleScanMode) {
		tempah=tempah|0x080;
	}
	SiSSetRegANDOR(SiSP3d4,0x09,~0x020,tempah);
	SiSREFIndex=OldREFIndex;
	return; 
}

VOID SiSSetCRT2ECLK(ULONG ROMAddr, USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT OldREFIndex,tempah,tempal;
	USHORT P3cc=SiSP3c9+3;
	OldREFIndex=(USHORT)SiSREFIndex;
	if (SIS_IF_DEF_TRUMPION==0) {  
		tempal=SiSGetReg2(P3cc);
		tempal=tempal&0x0C;
		SiSSetReg3(SiSP3c2,tempal);
		SiSREFIndex=SiSGetVCLKPtr(ROMAddr,ModeNo,HwDeviceExtension);
	} else {  
		SiSSetFlag=SiSSetFlag&(~ProgrammingCRT2);
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));	 
	  
		tempal=tempal&0x03F;

		if (tempal==0x02) { 
			SiSREFIndex=SiSREFIndex-Ext2StructSize;
		}
		SiSREFIndex=SiSGetVCLKPtr(ROMAddr,ModeNo,HwDeviceExtension);
		SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
	}
	tempal=0x02B;
	if (!(SiSVBInfo&SetInSlaveMode)) {
		tempal=tempal+3;
	}
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));  
	SiSSetReg1(SiSP3c4,tempal,tempah);
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex+1));
	tempal++; 
	SiSSetReg1(SiSP3c4,tempal,tempah);
	SiSREFIndex=OldREFIndex;
	return;
}

USHORT SiSGetLVDSDesPtr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempcl,tempbx,tempal,tempptr,LVDSDesPtrData;
	tempcl=LVDSDesDataLen;
	tempbx=SiSLCDTypeInfo;
	if (SiSLCDInfo&LCDNonExpanding) {
		tempbx=tempbx+16;
	}
	if (ModeNo<=0x13) {
		tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));	
	} else {
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));	 
	}
	tempal=tempal&0x1F;
	tempal=tempal*tempcl;
	tempbx=tempbx<<1;
	LVDSDesPtrData=*((USHORT *)(ROMAddr+ADR_LVDSDesPtrData));
	tempptr=*((USHORT *)(ROMAddr+LVDSDesPtrData+tempbx));
	tempptr=tempptr+tempal;
	return(tempptr);
}

BOOLEAN SiSGetLVDSCRT1Ptr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempal,tempbx,modeflag1; 
	USHORT LVDSCRT1DataPtr; 

	if (!(SiSVBInfo&SetInSlaveMode)) {
	return 0;
	}
	if (ModeNo<=0x13) {
		tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));	
	} else {
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));	 
	}
	tempal=tempal&0x3F;

	tempbx=SiSLCDResInfo;
	tempbx=tempbx-Panel800x600;
	if (SiSLCDInfo&LCDNonExpanding) {
		tempbx=tempbx+6;
	}
	modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));	
	if (modeflag1&HalfDCLK) {
		tempbx=tempbx+3;
	}
	tempbx=tempbx<<1;
	LVDSCRT1DataPtr=*((USHORT *)(ROMAddr+ADR_LVDSCRT1DataPtr));
	SiSREFIndex=*((USHORT *)(ROMAddr+LVDSCRT1DataPtr+tempbx));
	tempal=tempal*LVDSCRT1Len;
	SiSREFIndex=SiSREFIndex+tempal;
	return 1;
}

USHORT SiSGetLCDPtrIndex (VOID)
{
	USHORT index;

	index = (SiSLCDResInfo & 0x0F)-1;
	index *= 3;
	if (SiSLCDInfo&LCDNonExpanding)
		index += 2;
	else {
		if (!(SiSLCDInfo&LCDVESATiming))
			index++;
	}
	
	return index;
}

USHORT SiSGetTVPtrIndex(VOID)
{
	USHORT index;
  
	index = 0;
	if (SiSVBInfo&SetPALTV)
		index++;
	if (SiSVBInfo&SetCRT2ToHiVisionTV)  
		index++;
	index *= 2;

	if ((SiSVBInfo&SetInSlaveMode)&&(SiSSetFlag&TVSimuMode))
		index++;

	return index;
}


VOID SiSSetDelayComp(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT Part1Port;
	USHORT delay,index;

	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		index =*((USHORT *)(ROMAddr+CRT2Delay1Offset));	
		delay =*((USHORT *)(ROMAddr+index));
	} else { 
		if (SiSVBInfo&SetCRT2ToLCD) {
			index = SiSGetLCDPtrIndex();
			delay =*((USHORT *)(ROMAddr+LCDDelayPtr1Offset)); 
			delay =*((USHORT *)(ROMAddr+delay+index)); 
		} else {
			index = SiSGetTVPtrIndex();
			delay =*((USHORT *)(ROMAddr+TVDelayPtr1Offset)); 
			delay =*((USHORT *)(ROMAddr+delay+index)); 
		}
	}

	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	SiSSetRegANDOR(Part1Port,0x2D,~0x0F,delay);  
}

VOID SiSSetAntiFlicker(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT Part2Port;
	USHORT index,temp;

	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	index = SiSGetTVPtrIndex();
	index = (index>>1)<<1;
	if (ModeNo<=0x13) {
		index = index + *((USHORT *)(ROMAddr+SiSModeIDOffset+0x06));		
	} else {
		index = index + *((USHORT *)(ROMAddr+SiSModeIDOffset+0x0B));		
	}
	temp =*((USHORT *)(ROMAddr+TVAntiFlickPtrOffset));
	temp =*((USHORT *)(ROMAddr+temp+index));
	temp  <<= 4;

	SiSSetRegANDOR(Part2Port,0x0A,~0x70,temp);  
}


VOID SiSSetEdgeEnhance (PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT Part2Port;
	USHORT index,temp;

	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	index = SiSGetTVPtrIndex();
	index = (index>>1)<<1;
	if (ModeNo<=0x13) {
		index = index + *((USHORT *)(ROMAddr+SiSModeIDOffset+0x07));		
	} else {
		index = index + *((USHORT *)(ROMAddr+SiSModeIDOffset+0x0C));		
	}
	temp =*((USHORT *)(ROMAddr+TVEdgePtr1Offset));
	temp =*((USHORT *)(ROMAddr+temp+index));
	temp  <<= 5;

	SiSSetRegANDOR(Part2Port,0x3A,~0xE0,temp);  

}

VOID SiSSetYFilter(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT Part2Port;
	USHORT index,temp,i;

	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	index = SiSGetTVPtrIndex();
	index >>= 1;
	index <<=  5;
	if (ModeNo<=0x13) {
		temp =  *((USHORT *)(ROMAddr+SiSModeIDOffset+0x08));		
	} else {
		temp =  *((USHORT *)(ROMAddr+SiSModeIDOffset+0x0D));		
	}
	temp *= 4;
	if (SiSVBInfo&SetCRT2ToHiVisionTV)  
	temp = 0;
	index += temp;

	temp =*((USHORT *)(ROMAddr+TVYFilterPtr1Offset));
  
	for(i=0x35;i<=0x38;i++,temp++) {
		SiSSetReg1(Part2Port,i,*(UCHAR *)(ROMAddr+index+temp));
	}
}

VOID SiSSetPhaseIncr(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT Part2Port;
	USHORT index,temp,i;

	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	index = SiSGetTVPtrIndex();
	index <<= 2;

	temp =*((USHORT *)(ROMAddr+TVPhaseIncrPtr1Offset));

	for(i=0x31;i<=0x34;i++,temp++) {
		SiSSetReg1(Part2Port,i,*(UCHAR *)(ROMAddr+index+temp));
	}

}

VOID SiSOEM310Setting(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	SiSSetDelayComp(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
	if (SiSVBInfo&SetCRT2ToTV) {
		SiSSetAntiFlicker(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
		SiSSetPhaseIncr(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
		SiSSetYFilter(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
		SiSSetEdgeEnhance(HwDeviceExtension,BaseAddr,ROMAddr,ModeNo);
	}
}


BOOLEAN SiSOEMSetting(USHORT BaseAddr,ULONG ROMAddr,
	PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT ModeNo)
  
{  
	USHORT modeptr;
	modeptr=SiSSearchVBModeID(ROMAddr,ModeNo);	
	if (modeptr!=0) {
		SiSSetOEMData(BaseAddr,ROMAddr,HwDeviceExtension,modeptr);
		return 1;
	} else {
		return 0;
	}
}

USHORT SiSSearchVBModeID(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT index,modeptr,tablelength;
	UCHAR tempid;

	index=ModeNo;
	if (ModeNo<=0x13) {
		return(0);
	}

	modeptr=*((USHORT *)(ROMAddr+VBModeIDTableAddr));
	tablelength=VBModeStructSize;
	for(;;modeptr+=tablelength) {
		tempid=*((UCHAR *)(ROMAddr+modeptr+VB_ModeID));
		if (tempid==0xFF) {
			return(0);
		}
		if (tempid==ModeNo) {
			return(modeptr); 
		}
	}  
	return(0); 
}

VOID SiSSetOEMData(USHORT BaseAddr,ULONG ROMAddr,
	PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT modeptr)
{
	USHORT OEMUtiltemp;

	OEMUtiltemp=*((USHORT *)(ROMAddr+OEMUtilIDCodeAddr));
	if (OEMUtiltemp&OEMLCDEnable) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			SiSSetOEMLCDData(BaseAddr,ROMAddr,HwDeviceExtension,modeptr);
		}
	}
	if (SIS_IF_DEF_LVDS==0) { 
		if (OEMUtiltemp&OEMTVEnable) {
			if (SiSVBInfo&SetCRT2ToTV) {
				SiSSetOEMTVData(BaseAddr,ROMAddr,modeptr);
			}
		}
	}
	return;
}

VOID SiSSetOEMLCDData(USHORT BaseAddr,ULONG ROMAddr,
	PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT modeptr)
{
	USHORT oemlcdindex;
	oemlcdindex=SiSGetOEMLCDPtr(ROMAddr,HwDeviceExtension);
	SiSSetOEMLCDReg(BaseAddr,ROMAddr,oemlcdindex,modeptr);
}

VOID SiSSetOEMTVData(USHORT BaseAddr,ULONG ROMAddr,USHORT modeptr)
{
	USHORT oemtvptr;
	oemtvptr=SiSGetOEMTVPtr(ROMAddr,modeptr);
	SiSSetOEMTVReg(BaseAddr,ROMAddr,oemtvptr);
	return;
}

USHORT SiSGetOEMTVPtr(ULONG ROMAddr,USHORT modeptr)
{
	USHORT index,length,pbase,tempptr,oemtvptr,tempoffset;
  
	oemtvptr=0;
	index=*((UCHAR *)(ROMAddr+modeptr+VB_TVTableIndex));
	length=3;
	if (SiSVBInfo&SetInSlaveMode) {
		pbase=0;
	} else {
		pbase=4;
	}
	if (SiSVBInfo&SetCRT2ToSCART) {
		length=2;
		pbase=pbase+2;
	} else if (SiSVBInfo&SetCRT2ToHiVisionTV) {
		length=1;
		pbase=pbase+3;
	} else if (SiSVBInfo&SetPALTV) {
		pbase=pbase+1;
	}

	tempptr=*((USHORT *)(ROMAddr+OEMTVPtrAddr));
	pbase=pbase<<1;
	oemtvptr=*((USHORT *)(ROMAddr+tempptr+pbase));
	tempoffset=index*length;
	oemtvptr=oemtvptr+tempoffset;
	return(oemtvptr);
}

VOID SiSSetOEMTVReg(USHORT BaseAddr,ULONG ROMAddr,USHORT oemtvptr)
{
	USHORT OEMUtilID,Part1Port,Part2Port;
	USHORT tempah,tempptr,i,temp;

	OEMUtilID=*((USHORT *)(ROMAddr+OEMUtilIDCodeAddr));

	if (OEMUtilID&OEMTVDelayEnable) {
		Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
		tempah=*((UCHAR *)(ROMAddr+oemtvptr));
		tempah=(tempah&0x0F)<<2;
		SiSSetRegANDOR(Part1Port,0x13,~0x3C,tempah); 
	}
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	if (OEMUtilID&OEMTVFlickerEnable) {
		tempah=*((UCHAR *)(ROMAddr+oemtvptr));
		tempah=tempah&0x70;
		SiSSetRegANDOR(Part2Port,0x0A,~0x70,tempah); 
	}
	if (!(SiSVBInfo&SetCRT2ToHiVisionTV)) { 
		if (OEMUtilID&OEMTVPhaseEnable) {
			tempptr=*((USHORT *)(ROMAddr+PhaseTableAddr));
			tempah=*((UCHAR *)(ROMAddr+oemtvptr+1));
			tempah=tempah*PhaseTableSize;
			tempptr=tempptr+tempah;
			for(i=0x31;i<=0x34;i++,tempptr++) {
				tempah=*((UCHAR *)(ROMAddr+tempptr));
				SiSSetReg1(Part2Port,i,tempah);
			}
		}
	}
	if (!(SiSVBInfo&(SetCRT2ToSCART|SetCRT2ToHiVisionTV))) { 
		if (OEMUtilID&OEMTVFilterEnable) {
			tempah=*((UCHAR *)(ROMAddr+oemtvptr+2));
			temp=(tempah>>4)<<1;	
			if (SiSVBInfo&SetPALTV) { 
				tempptr=*((USHORT *)(ROMAddr+PALFilterTableAddr));
				tempptr=*((USHORT *)(ROMAddr+tempptr+temp));
			} else {  
				tempptr=*((USHORT *)(ROMAddr+NTSCFilterTableAddr));
				tempptr=*((USHORT *)(ROMAddr+tempptr+temp));
			}
			tempah=(tempah&0x0F)*FilterTableSize;
			tempptr=tempptr+tempah;
			for(i=0x35;i<=0x38;i++,tempptr++) {
				tempah=*((UCHAR *)(ROMAddr+tempptr));
				SiSSetReg1(Part2Port,i,tempah);
			}
		}
	}
	return; 
}

USHORT SiSGetOEMLCDPtr(ULONG ROMAddr,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT index,BIOSIDCode,temp,OEMLCDPIDTable;

	if (SIS_IF_DEF_LVDS==0) { 
		index= SiSLCDResInfo - Panel1024x768;
		if (!(SiSSetFlag&LCDVESATiming)) {
			index=index+4;
			if (HwDeviceExtension->jChipID == SIS_Spartan) {
				if (HwDeviceExtension->uRevisionID == 0) { 
					index=index+4;	
				} 
			} else if (HwDeviceExtension->jChipID == SIS_Trojan) {
				if (HwDeviceExtension->uRevisionID < 3) { 
					index=index+4;	
				} 
			}
		}
		if (SiSLCDResInfo==Panel1024x768) {
			if (SiSLCDInfo&LCDNonExpanding) {
				index=index+3;
			}
		}
		BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
		if (BIOSIDCode&OEMLCDPanelIDSupport) {
			temp=(USHORT)SiSLCDTypeInfo; 
			OEMLCDPIDTable=*((USHORT *)(ROMAddr+OEMLCDPIDTableAddr));
			index=*((UCHAR *)(ROMAddr+OEMLCDPIDTable+temp));
			if (!(SiSSetFlag&LCDVESATiming)) { 
				index++;
			}
		}
		index=index<<1;
		return(index);
	} else { 
		temp=0;
		index= SiSLCDResInfo - Panel800x600;
		BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
		if (BIOSIDCode&OEMLCDPanelIDSupport) {
			temp=(USHORT)SiSLCDTypeInfo; 
			OEMLCDPIDTable=*((USHORT *)(ROMAddr+OEMLCDPIDTableAddr));
			index=*((UCHAR *)(ROMAddr+OEMLCDPIDTable+temp));	
		}
		index=index*OEMLVDSPIDTableSize;
		index=index+temp;
		if (SiSVBInfo&SetInSlaveMode) {
			index=index+2;
		}
		if (SiSLCDInfo&LCDNonExpanding) {
			index=index+1;
		}
		index=index<<1;
		return(index);  
	}
}

VOID SiSSetOEMLCDReg(USHORT BaseAddr,ULONG ROMAddr,USHORT oemlcdindex,USHORT modeptr)
{
	USHORT OEMUtilID,BIOSIDCode;
	USHORT oemlcdptr,tempptr=0,tempoffset=0,tempah;
	USHORT Part1Port=0,Part2Port,i;

	if (SIS_IF_DEF_LVDS==0) { 
		OEMUtilID=*((USHORT *)(ROMAddr+OEMUtilIDCodeAddr));
		if (OEMUtilID&OEMLCDDelayEnable) {
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+OEMLCDPtr_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+OEMLCDPtr_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDTableIndex));
			oemlcdptr=oemlcdptr+tempoffset;
			Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr));
			tempah=(tempah<<2)&0x03C;
			SiSSetRegANDOR(Part1Port,0x13,~0x3C,tempah); 
		}
	
		Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
		if (OEMUtilID&OEMLCDPOSEnable) {
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+LCDHPosTable_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+LCDHPosTable_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDHIndex));
			tempoffset=tempoffset*LCDHPosTableSize;
			oemlcdptr=oemlcdptr+tempoffset;
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr));	
			SiSSetReg1(Part2Port,0x1C,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+1));
			SiSSetRegANDOR(Part2Port,0x1D,~0x0F0,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+2));
			SiSSetReg1(Part2Port,0x1F,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+3));
			SiSSetRegANDOR(Part2Port,0x20,~0x0F0,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+4));
			SiSSetReg1(Part2Port,0x21,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+5));
			SiSSetReg1(Part2Port,0x23,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+6));
			SiSSetRegANDOR(Part2Port,0x25,~0x0F,tempah);
			  
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+LCDVPosTable_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+LCDVPosTable_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDVIndex)); 
			tempoffset=tempoffset*LCDVPosTableSize;
			oemlcdptr=oemlcdptr+tempoffset;
			for(i=1;i<=2;i++,oemlcdptr++) {	
				tempah=*((UCHAR *)(ROMAddr+oemlcdptr));
				SiSSetReg1(Part2Port,i,tempah);
			}
			for(i=4;i<=6;i++,oemlcdptr++) {
				tempah=*((UCHAR *)(ROMAddr+oemlcdptr));
				SiSSetReg1(Part2Port,i,tempah);
			}		  	
		}
		return;
	} else { 
		OEMUtilID=*((USHORT *)(ROMAddr+OEMUtilIDCodeAddr));
		if (OEMUtilID&OEMLCDDelayEnable) {
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+OEMLCDPtr_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+OEMLCDPtr_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDTableIndex));
			oemlcdptr=oemlcdptr+tempoffset;
			Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr));
			tempah=(tempah<<2)&0x03C;
			SiSSetRegANDOR(Part1Port,0x13,~0x3C,tempah); 
		}
		if (OEMUtilID&OEMLCDPOSEnable) {
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+LCDHPosTable_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+LCDHPosTable_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDHIndex));
			tempoffset=tempoffset*LVDSHPosTableSize;
			oemlcdptr=oemlcdptr+tempoffset;
			for(i=0x14;i<=0x17;i++,oemlcdptr++) {
				tempah=*((UCHAR *)(ROMAddr+oemlcdptr));	
				SiSSetReg1(Part1Port,i,tempah);
			}
			  
			BIOSIDCode=*((USHORT *)(ROMAddr+BIOSIDCodeAddr));
			if (BIOSIDCode&OEMLCDPanelIDSupport) {
				tempptr=*((USHORT *)(ROMAddr+LCDVPosTable_2Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			} else { 
				tempptr=*((USHORT *)(ROMAddr+LCDVPosTable_1Addr));
				oemlcdptr=*((USHORT *)(ROMAddr+tempptr+oemlcdindex));
			}
			tempoffset=*((UCHAR *)(ROMAddr+modeptr+VB_LCDVIndex)); 
			tempoffset=tempoffset*LVDSVPosTableSize;
			oemlcdptr=oemlcdptr+tempoffset;
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr));	
			SiSSetReg1(Part1Port,0x18,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+1));
			SiSSetRegANDOR(Part1Port,0x19,~0x0F,tempah);
			tempah=*((UCHAR *)(ROMAddr+oemlcdptr+2));
			SiSSetRegANDOR(Part1Port,0x1A,~0x03F,tempah);
			oemlcdptr=oemlcdptr+3;
			for(i=0x1B;i<=0x1D;i++,oemlcdptr++) {
				tempah=*((UCHAR *)(ROMAddr+oemlcdptr));
				SiSSetReg1(Part1Port,i,tempah);
			}		  	
		}
		return;	 
	}
}


USHORT SiSSaveRegisters(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	UCHAR *regptr;
	USHORT length;
	USHORT Part1Port,Part2Port,Part3Port,Part4Port,Part5Port;
	USHORT  BaseAddr = (USHORT)HwDeviceExtension->IOAddress;

	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part2Port=Part1Port+0x0C;
	Part3Port=Part1Port+0x0E;
	Part4Port=Part1Port+0x10;
	Part5Port=Part1Port+0x12;
	SiSP3c4=BaseAddr+0x14;
	SiSP3d4=BaseAddr+0x24;
	SiSP3c0=BaseAddr+0x10;
	SiSP3ce=BaseAddr+0x1e;
	SiSP3c2=BaseAddr+0x12;
	SiSP3ca=BaseAddr+0x1a;
	SiSP3c6=BaseAddr+0x16;
	SiSP3c7=BaseAddr+0x17;
	SiSP3c8=BaseAddr+0x18;
	SiSP3c9=BaseAddr+0x19;
	SiSP3da=BaseAddr+0x2A;

	regptr=(UCHAR *)(HwDeviceExtension->pSavedRegisters);

	length=SiSSaveSR(regptr);
	regptr+=length;

	length=SiSSaveMISC(regptr);
	regptr+=length;
	length=SiSSaveAR(regptr);
	regptr+=length;
	length=SiSSaveGR(regptr);
	regptr+=length;

	length=SiSSavePart1(regptr,Part1Port);
	regptr+=length;
	length=SiSSavePart2(regptr,Part2Port);
	regptr+=length;
	length=SiSSaveCR(regptr);
	regptr+=length;

	return(length);
  
}

USHORT SiSSaveSR(UCHAR *regptr) 
{
	USHORT i,length;
	UCHAR *ptr;

	ptr=regptr;
	SiSSetReg1(SiSP3c4,0x05,0x86);
	length=0;
	for(i=0;i<=4;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(SiSP3c4,i);
		ptr++;	
	}
	for(i=6;i<=0x36;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(SiSP3c4,i);
		ptr++;
	}
	return(length);
}

USHORT SiSSaveCR(UCHAR *regptr) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x18;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(SiSP3d4,i);
		ptr++;	
	}
	for(i=0x30;i<=0x37;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(SiSP3d4,i);
		ptr++;
	}
	return(length);
}

USHORT SiSSaveMISC(UCHAR *regptr) 
{
	USHORT length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;

	*ptr=(UCHAR)SiSGetReg2((USHORT)(SiSP3c4+0x08)); 
	ptr++;length++;
	*ptr=(UCHAR)SiSGetReg2((USHORT)(SiSP3c4+0x06)); 
	ptr++;length++;
	*ptr=(UCHAR)SiSGetReg2((USHORT)(SiSP3c4-0x01)); 
	ptr++;length++;	

	return(length);
}

USHORT SiSSaveAR(UCHAR *regptr) 
{
	USHORT i,length;
	UCHAR *ptr;

	ptr=regptr;
	length=0;
	for(i=0;i<=0x14;i++,length++) {
		SiSGetReg2(SiSP3da);										
		SiSSetReg3(SiSP3c0,i);									 
		*ptr=(UCHAR)SiSGetReg2((USHORT)(SiSP3c4-3));	
		ptr++;	
	}
	return(length);
}

USHORT SiSSaveGR(UCHAR *regptr) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x8;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1((USHORT)(SiSP3c4+10),i);
		ptr++;	
	}
	return(length);
}

USHORT SiSRestoreRegisters(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	UCHAR *regptr;
	USHORT length;
	USHORT Part1Port,Part2Port,Part3Port,Part4Port,Part5Port;
	USHORT  BaseAddr = (USHORT)HwDeviceExtension->IOAddress;

	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part2Port=Part1Port+0x0C;
	Part3Port=Part1Port+0x0E;
	Part4Port=Part1Port+0x10;
	Part5Port=Part1Port+0x12;
	SiSP3c4=BaseAddr+0x14;
	SiSP3d4=BaseAddr+0x24;
	SiSP3c0=BaseAddr+0x10;
	SiSP3ce=BaseAddr+0x1e;
	SiSP3c2=BaseAddr+0x12;
	SiSP3ca=BaseAddr+0x1a;
	SiSP3c6=BaseAddr+0x16;
	SiSP3c7=BaseAddr+0x17;
	SiSP3c8=BaseAddr+0x18;
	SiSP3c9=BaseAddr+0x19;
	SiSP3da=BaseAddr+0x2A;

	regptr=(UCHAR *)(HwDeviceExtension->pSavedRegisters);

	length=SiSRestoreSR(regptr);
	regptr+=length;

	length=SiSRestoreMISC(regptr);
	regptr+=length;
	length=SiSRestoreAR(regptr);
	regptr+=length;
	length=SiSRestoreGR(regptr);
	regptr+=length;
  
	length=SiSRestorePart1(regptr,Part1Port);
	regptr+=length;
	length=SiSRestorePart2(regptr,Part2Port);
	regptr+=length;
	length=SiSRestoreCR(regptr);
	regptr+=length;

	return(length);
}

USHORT SiSRestoreSR(UCHAR *regptr) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	SiSSetReg1(SiSP3c4,0x05,0x86);
	length=0;
	for(i=0;i<=4;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(SiSP3c4,i,temp);
		ptr++;	
	}
	for(i=6;i<=0x36;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(SiSP3c4,i,temp);
		ptr++;
	}
	return(length);
}

USHORT SiSRestoreCR(UCHAR *regptr) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x18;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(SiSP3d4,i,temp);
		ptr++;	
	}
	for(i=0x30;i<=0x37;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(SiSP3d4,i,temp);
		ptr++;
	}
	  
	return(length);
}

USHORT SiSRestoreMISC(UCHAR *regptr) 
{
	USHORT length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	temp=(USHORT)(*(UCHAR*)ptr);
	SiSSetReg3((USHORT)(SiSP3c4-2),temp); 
	ptr++;length++;
	temp=(USHORT)(*(UCHAR*)ptr);
	SiSSetReg3((USHORT)(SiSP3d4+0x06),temp); 
	ptr++;length++;
	temp=(USHORT)(*(UCHAR*)ptr);
	SiSSetReg3((USHORT)(SiSP3c4-0x01),temp); 
	ptr++;length++;	

	return(length);
}

USHORT SiSRestoreAR(UCHAR *regptr) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x14;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSGetReg2(SiSP3da);										
		SiSSetReg3(SiSP3c0,i);									 
		SiSSetReg3(SiSP3c0,temp);			 
		ptr++;	
	}
	return(length);
}

USHORT SiSRestoreGR(UCHAR *regptr) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x8;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1((USHORT)(SiSP3c4+10),i,temp);
		ptr++;	
	}
	return(length);
}

USHORT SiSSavePart1(UCHAR *regptr,USHORT Part1Port) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	SiSSetReg1(Part1Port,0x24,0x01);
	length=0;
	for(i=0;i<=0x23;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(Part1Port,i);
		ptr++;	
	}
	return(length);
}

USHORT SiSSavePart2(UCHAR *regptr,USHORT Part2Port) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x45;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(Part2Port,i);
		ptr++;	
	}
	return(length);
}

USHORT SiSSavePart3(UCHAR *regptr,USHORT Part3Port) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x3E;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(Part3Port,i);
		ptr++;	
	}
	return(length);
}

USHORT SiSSavePart4(UCHAR *regptr,USHORT Part4Port) 
{
	USHORT i,length;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0x0A;i<=0x1B;i++,length++) {
		*ptr=(UCHAR)SiSGetReg1(Part4Port,i);
		ptr++;	
	}
	return(length);
}

USHORT SiSSavePart5(UCHAR *regptr,USHORT Part5Port) 
{
	USHORT i,j,length;
	UCHAR *ptr;
	USHORT Pindex,Pdata;
	ptr=regptr;
	length=0;
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	SiSSetReg3(Pindex,0);
	for(i=0x0;i<=0x255;i++) {
		for(j=0;j<3;j++,length++) {	
			*ptr=(UCHAR)SiSGetReg2(Pdata);
			ptr++;
		}	
	}
	return(length);
}


USHORT SiSRestorePart1(UCHAR *regptr,USHORT Part1Port) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	SiSSetReg1(Part1Port,0x24,0x01);
	length=0;
	for(i=0;i<=0x23;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(Part1Port,i,temp);
		ptr++;	
	}
	return(length);
}

USHORT SiSRestorePart2(UCHAR *regptr,USHORT Part2Port) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x45;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(Part2Port,i,temp);
		ptr++;	
	}
	return(length);
}

USHORT SiSRestorePart3(UCHAR *regptr,USHORT Part3Port) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0;i<=0x3E;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(Part3Port,i,temp);
		ptr++;	
	}
	return(length);
}

USHORT SiSRestorePart4(UCHAR *regptr,USHORT Part4Port) 
{
	USHORT i,length,temp;
	UCHAR *ptr;
	ptr=regptr;
	length=0;
	for(i=0x0A;i<=0x1B;i++,length++) {
		temp=(USHORT)(*(UCHAR*)ptr);
		SiSSetReg1(Part4Port,i,temp);
		ptr++;	
	}
	return(length);
}

USHORT SiSRestorePart5(UCHAR *regptr,USHORT Part5Port) 
{
	USHORT i,j,length,temp;
	UCHAR *ptr;
	USHORT Pindex,Pdata;
  
	ptr=regptr;
	length=0;
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	SiSSetReg3(Pindex,0);
	for(i=0x0;i<=0x255;i++) {
		for(j=0;j<3;j++,length++) {
			temp=(USHORT)(*(UCHAR*)ptr);
			SiSSetReg1(Part5Port,i,temp);	
			ptr++;
		}	
	}
	return(length);
}



