#include <linux/sisfb.h>
#include <linux/kernel.h>
#include "init310.h"

BOOLEAN SiSSetMode310(PHW_DEVICE_EXTENSION HwDeviceExtension, USHORT ModeNo);
BOOLEAN SiSInit310(PHW_DEVICE_EXTENSION HwDeviceExtension);

#if defined(ALLOC_PRAGMA)
#pragma alloc_text(PAGE,SiSSetMode310)
#pragma alloc_text(PAGE,SiSInit310)
#endif

BOOLEAN SiSInit310(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	ULONG   ROMAddr  = (ULONG)HwDeviceExtension->VirtualRomBase;
	ULONG   FBAddr   = (ULONG)HwDeviceExtension->VirtualVideoMemoryAddress;
	USHORT  BaseAddr = (USHORT)HwDeviceExtension->IOAddress;
	UCHAR   i,temp,AGP;
	ULONG   j,k,ulTemp;
	UCHAR   SR07,SR11,SR19,SR1A,SR1F,SR21,SR22,SR23,SR24,SR25,SR31,SR32,SR33;
	UCHAR   SR14;
	USHORT  Part1Port,Part2Port,Part4Port;
	ULONG   Temp;
   
	if (ROMAddr==0)   return (FALSE);
	if (FBAddr==0)    return (FALSE);
	if (BaseAddr==0)  return (FALSE);
	if (HwDeviceExtension->jChipID > SIS_GlamourII)
		if (!HwDeviceExtension->bIntegratedMMEnabled)  return (FALSE);

	SiSP3c4=BaseAddr+0x14;
	SiSP3d4=BaseAddr+0x24;
	SiSP3c0=BaseAddr+0x10;
	SiSP3ce=BaseAddr+0x1e;
	SiSP3c2=BaseAddr+0x12;
	SiSP3ca=BaseAddr+0x1a;
	SiSP3c6=BaseAddr+0x16;
	SiSP3c7=BaseAddr+0x17;
	SiSP3c8=BaseAddr+0x18;
	SiSP3c9=BaseAddr+0x19;
	SiSP3da=BaseAddr+0x2A;
	SiSSet_LVDS_TRUMPION(); 

	SiSSetReg1(SiSP3c4,0x05,0x86);                     
   
	SR14 = (UCHAR)SiSGetReg1(SiSP3c4,0x14);
	SR19 = (UCHAR)SiSGetReg1(SiSP3c4,0x19);
	SR1A = (UCHAR)SiSGetReg1(SiSP3c4,0x1A);
   
	for(i=0x06;i< 0x20;i++) SiSSetReg1(SiSP3c4,i,0);   
	for(i=0x21;i<=0x27;i++) SiSSetReg1(SiSP3c4,i,0);   
	for(i=0x31;i<=0x3D;i++) SiSSetReg1(SiSP3c4,i,0);
	for(i=0x30;i<=0x37;i++) SiSSetReg1(SiSP3d4,i,0);

	if (HwDeviceExtension->jChipID > SIS_GlamourII)
		temp=(UCHAR)SR1A;                                   
	else {
    
		temp=*((UCHAR *)(ROMAddr+SoftSettingAddr));
		if ((temp&SoftDRAMType)==0) {               
			temp=(UCHAR)SiSGetReg1(SiSP3c4,0x3A);                     
		}
	} 
	SiSRAMType=temp&0x03; 
	SiSSetMemoryClock(ROMAddr);
   
	for(k=0; k<5; k++) {
		for(j=0; j<0xffff; j++) {
			ulTemp = (ULONG)SiSGetReg1(SiSP3c4, 0x05);
		}
	}
	Temp = (ULONG)SiSGetReg1(SiSP3c4, 0x3C);
	Temp = Temp | 0x01;                 
	SiSSetReg1(SiSP3c4, 0x3C, (USHORT)Temp);
	for(k=0; k<5; k++) {
		for(j=0; j<0x1000; j++) {
			Temp = (ULONG)SiSGetReg1(SiSP3c4, 0x05);
		}
	}
	Temp = (ULONG)SiSGetReg1(SiSP3c4, 0x3C);
	Temp = Temp & 0xFE;                 
	SiSSetReg1(SiSP3c4, 0x3C, (USHORT)Temp);
	for(k=0; k<5; k++) {
		for(j=0; j<0x1000; j++) {
		Temp = (ULONG)SiSGetReg1(SiSP3c4, 0x05);
		}
	}
   
	SR07=*((UCHAR *)(ROMAddr+SR07_OFFSET));
	SiSSetReg1(SiSP3c4,0x07,SR07);
	if (HwDeviceExtension->jChipID == SIS_GlamourII ) {
		for(i=0x15;i<0x1C;i++) {
			temp=*((UCHAR *)(ROMAddr+SR15_OFFSET+((i-0x15)*4)+SiSRAMType));
			SiSSetReg1(SiSP3c4,i,temp);
		}

		for(i=0x40;i<=0x44;i++) {
			temp=*((UCHAR *)(ROMAddr+CR40_OFFSET+(i-0x40)*4+SiSRAMType));
			SiSSetReg1(SiSP3d4,i,temp);
		}
	}

	SR1F=*((UCHAR *)(ROMAddr+SR1F_OFFSET));
	SiSSetReg1(SiSP3c4,0x1F,SR1F);

	AGP=1;                                       
	temp=(UCHAR)SiSGetReg1(SiSP3c4,0x3A);
	temp=temp&0x30;
	if (temp==0x30) AGP=0;                        

	SR21=*((UCHAR *)(ROMAddr+SR21_OFFSET));
	if (AGP==0) SR21=SR21&0xEF;   
	SiSSetReg1(SiSP3c4,0x21,SR21);

	SR22=*((UCHAR *)(ROMAddr+SR22_OFFSET));
	if (AGP==1) SR22=SR22&0x20;   
	SiSSetReg1(SiSP3c4,0x22,SR22);

	SR23=*((UCHAR *)(ROMAddr+SR23_OFFSET));
	SiSSetReg1(SiSP3c4,0x23,SR23);

	SR24=*((UCHAR *)(ROMAddr+SR24_OFFSET));
	SiSSetReg1(SiSP3c4,0x24,SR24);

	SR25=*((UCHAR *)(ROMAddr+SR25_OFFSET));
	SiSSetReg1(SiSP3c4,0x25,SR25);
   
	SiSSetReg1(SiSP3c4,0x27,0x1F);

	SR31=*((UCHAR *)(ROMAddr+SR31_OFFSET));  
	SiSSetReg1(SiSP3c4,0x31,SR31);

	SR32=*((UCHAR *)(ROMAddr+SR32_OFFSET));
	SiSSetReg1(SiSP3c4,0x32,SR32);

	SR33=*((UCHAR *)(ROMAddr+SR33_OFFSET));  
	SiSSetReg1(SiSP3c4,0x33,SR33);

	SR11=0x0F;
	SiSSetReg1(SiSP3c4,0x11,SR11);

	if (SiSBridgeIsOn(BaseAddr)==1) {
		SiSUnLockCRT2(HwDeviceExtension, BaseAddr);
		Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
		Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
		Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
		temp = *((UCHAR *)(ROMAddr+VB310Data_1_2_Offset));  
		SiSSetReg1(Part1Port,0x02,temp);
		SiSSetReg1(Part1Port,0x2E,0x08);

		SiSSetReg1(Part2Port,0x00,0x1C);
     
		temp = *((UCHAR *)(ROMAddr+VB310Data_4_D_Offset));  
		SiSSetReg1(Part4Port,0x0D,temp);
		temp = *((UCHAR *)(ROMAddr+VB310Data_4_E_Offset));  
		SiSSetReg1(Part4Port,0x0E,temp);
		temp = *((UCHAR *)(ROMAddr+VB310Data_4_10_Offset));  
		SiSSetReg1(Part4Port,0x10,temp);
     
		SiSLockCRT2(HwDeviceExtension, BaseAddr);
	}
   
	if (SIS_IF_DEF_LVDS==1) {  
		temp=ExtChipLVDS;
	} else if (SIS_IF_DEF_TRUMPION==1) { 
		temp=ExtChipTrumpion;
	} else { 
		temp=ExtChip301;           
	}
	SiSSetReg1(SiSP3d4,0x37,temp);

	if ( HwDeviceExtension->jChipID == SIS_GlamourII ) {
/*
		if (HwDeviceExtension->bSkipDramSizing == TRUE) {
			SiSSetDRAMModeRegister(ROMAddr);
			temp = HwDeviceExtension->ujSR13;  	
			SiSSetReg1(SiSP3c4,0x13,temp);
			temp = HwDeviceExtension->ujSR14;
			SiSSetReg1(SiSP3c4,0x14,temp);
		} else
*/
         SiSSetDRAMSize(HwDeviceExtension);
	} else {
		SiSSetReg1(SiSP3c4,0x14,SR14);
		SiSSetReg1(SiSP3c4,0x19,SR19);
		SiSSetReg1(SiSP3c4,0x1A,SR1A);
	}

	SiSSetReg3(SiSP3c6,0xff);                                
	SiSClearDAC(SiSP3c8);                                    
   
	SiSDetectMonitor301(HwDeviceExtension);    
	SiSGetSenseStatus301(HwDeviceExtension,BaseAddr,ROMAddr);
   
	return(TRUE);
}


VOID SiSSet_LVDS_TRUMPION()
{
	SIS_IF_DEF_LVDS=0;
	SIS_IF_DEF_TRUMPION=0;    
}

UCHAR SiSGet310DRAMType(ULONG   ROMAddr)
{
	UCHAR   data,SoftSetting;

	SoftSetting=*((UCHAR *)(ROMAddr+SoftSetting_OFFSET));

	if (SoftSetting&SoftDRAMType)
		data = SoftSetting & 0x03;
	else
		data=SiSGetReg1(SiSP3c4,0x3a) & 0x03;

	return data;
}

VOID SiSDelay15us(ULONG ulMicrsoSec)
{
}

VOID SiSSDR_MRS(VOID)
{
	USHORT  data;

	data=SiSGetReg1(SiSP3c4,0x16);
	data=data & 0x3F;          
	SiSSetReg1(SiSP3c4,0x16,data);   
	SiSDelay15us(0x100);
	data=data | 0x80;          
	SiSSetReg1(SiSP3c4,0x16,data);   
	SiSDelay15us(0x100);
}

VOID SiSDDR_MRS(VOID)
{
	USHORT  data;
   
	data=SiSGetReg1(SiSP3c4,0x16);
	data &= 0x0F;
	data |= 0x10;
	SiSSetReg1(SiSP3c4,0x16,data);
   
	data |= 0xC0;
	SiSSetReg1(SiSP3c4,0x16,data);
   
	data &= 0x0F;
	data |= 0x20;
	SiSSetReg1(SiSP3c4,0x16,data);
   
	data |= 0x80;
	SiSSetReg1(SiSP3c4,0x16,data);
}

VOID SiSSetDRAMModeRegister(ULONG ROMAddr)
{
	if (SiSGet310DRAMType(ROMAddr)<2) {
		SiSSDR_MRS();
	} else {
		SiSDDR_MRS();
	}
}

VOID SiSDisableRefresh(VOID)
{
	USHORT  data;

	data=SiSGetReg1(SiSP3c4,0x17);
	data &= 0xF8;
	SiSSetReg1(SiSP3c4,0x17,data);

	data=SiSGetReg1(SiSP3c4,0x19);
	data |= 0x03;
	SiSSetReg1(SiSP3c4,0x19,data);
}

VOID SiSEnableRefresh(ULONG ROMAddr)
{
	USHORT  data;

	data=SiSGetReg1(SiSP3c4,0x17);
	data &= 0xF8;
	data |= 0x01;            

	data=*((UCHAR *)(ROMAddr+SR17_OFFSET+SiSRAMType));
	SiSSetReg1(SiSP3c4,0x17,data);

	data=SiSGetReg1(SiSP3c4,0x19);
	data &= 0xFC;
	data=*((UCHAR *)(ROMAddr+SR19_OFFSET+SiSRAMType));
	SiSSetReg1(SiSP3c4,0x19,data);
}

VOID SiSDisableChannelInterleaving(int index,USHORT SIS_DDRDRAM_TYPE[][5])
{
	USHORT  data;

	data=SiSGetReg1(SiSP3c4,0x15);
	data &= 0x1F;
	switch (SIS_DDRDRAM_TYPE[index][3]) {
	case 64:
		data |= 0;      break;
	case 32:
		data |= 0x20;   break;
	case 16:
		data |= 0x40;   break;
	case 4:
		data |= 0x60;   break;
	}
	SiSSetReg1(SiSP3c4,0x15,data);
}


VOID SiSSetDRAMSizingType(int index,USHORT DRAMTYPE_TABLE[][5])
{
	USHORT  data;
		
	data = DRAMTYPE_TABLE[index][4];
	SiSSetReg1(SiSP3c4,0x13,data);
}


VOID SiSCheckBusWidth(ULONG ROMAddress,ULONG FBAddress)
{
	USHORT  data;
	PULONG  pVideoMemory;

	pVideoMemory = (PULONG) FBAddress;
	if (SiSGet310DRAMType(ROMAddress)<2) {
		SiSSetReg1(SiSP3c4,0x13,0x00);
		SiSSetReg1(SiSP3c4,0x14,0x12);

		SiSChannelAB = 0;
		SiSDataBusWidth = 128;
		pVideoMemory[0] = 0x01234567;
		pVideoMemory[1] = 0x456789AB;
		pVideoMemory[2] = 0x89ABCDEF;
		pVideoMemory[3] = 0xCDEF0123;
		pVideoMemory[4] = 0x55555555;
		pVideoMemory[5] = 0x55555555;
		pVideoMemory[6] = 0xFFFFFFFF;
		pVideoMemory[7] = 0xFFFFFFFF;
		if ((pVideoMemory[3]!=0xCDEF0123) || (pVideoMemory[2] != 0x89ABCDEF)) {
			SiSDataBusWidth = 64;
			SiSChannelAB = 0;
			data=SiSGetReg1(SiSP3c4,0x14);
			SiSSetReg1(SiSP3c4,  0x14, (USHORT) (data & 0xFD));
		}
     
		if ((pVideoMemory[1]!=0x456789AB) || (pVideoMemory[0] != 0x01234567)) {
			SiSDataBusWidth = 64;
			SiSChannelAB = 1;
			data=SiSGetReg1(SiSP3c4,0x14);
			SiSSetReg1(SiSP3c4,0x14,(USHORT)((data&0xFD)|0x01));
		}
		return;
	} else {
		SiSSetReg1(SiSP3c4,0x13,0x00);
		SiSSetReg1(SiSP3c4,0x14,0x02); 
     
		SiSChannelAB = 0;
		SiSDataBusWidth = 64;
		pVideoMemory[0] = 0x01234567;
		pVideoMemory[1] = 0x456789AB;
		pVideoMemory[2] = 0x89ABCDEF;
		pVideoMemory[3] = 0xCDEF0123;
		pVideoMemory[4] = 0x55555555;
		pVideoMemory[5] = 0x55555555;
		pVideoMemory[6] = 0xAAAAAAAA;
		pVideoMemory[7] = 0xAAAAAAAA;

		if (pVideoMemory[1] != 0x456789AB) {
			if (pVideoMemory[0] == 0x01234567) {
				SiSDataBusWidth = 32;
				SiSSetReg1(SiSP3c4,0x14,0x00);
			} else {
				SiSSetReg1(SiSP3c4,0x14,0x03);

				SiSChannelAB = 1;
				if (pVideoMemory[1] != 0x456789AB) {
					SiSDataBusWidth = 32;
					SiSSetReg1(SiSP3c4,0x14,0x01);
				} else {
           
				}
			}
		} else {
			if (pVideoMemory[0] == 0x01234567) {
         
			} else {
				SiSSetReg1(SiSP3c4,0x14,0x03);
         
				SiSChannelAB = 1;
				if (pVideoMemory[1] != 0x456789AB) {
					SiSDataBusWidth = 32;
					SiSSetReg1(SiSP3c4,0x14,0x01);
				} else {
				           
				}
			}
		}
	}
}

int SiSSetRank(int index,UCHAR RankNo,UCHAR SiSChannelAB,USHORT DRAMTYPE_TABLE[][5])
{
	USHORT  data;
	int RankSize;

	if ((RankNo==2)&&(DRAMTYPE_TABLE[index][0]==2))
		return 0;

	RankSize = DRAMTYPE_TABLE[index][3] * SiSDataBusWidth/64;

	if (RankNo*RankSize<=128) {
		data = 0;
		while ((RankSize>>=1)>0) {
			data+=0x10;
		}
		data |= (RankNo-1)<<2;
		data |= (SiSDataBusWidth/64)&2;
		data |= SiSChannelAB;
		SiSSetReg1(SiSP3c4,0x14,data);
		SiSSDR_MRS();
    
		return 1;
	} else
		return 0;
}

int SiSSetDDRChannel(int index,UCHAR ChannelNo,UCHAR SiSChannelAB,USHORT DRAMTYPE_TABLE[][5])
{
	USHORT  data;
	int RankSize;

	RankSize = DRAMTYPE_TABLE[index][3];
	if (ChannelNo*RankSize<=128) {
		data = 0;
		while ((RankSize>>=1)>0) {
			data+=0x10;
		}
		if (ChannelNo==2)
			data |= 0x0C;

		data |= (SiSDataBusWidth/32)&2;
		data |= SiSChannelAB;
		SiSSetReg1(SiSP3c4,0x14,data);

		SiSDDR_MRS();
    
		return 1;
	} else
		return 0;
}


int SiSCheckColumn(int index,USHORT DRAMTYPE_TABLE[][5],ULONG FBAddress)
{
	int i;
	ULONG Increment,Position;

  
	Increment = 1<<(10 + SiSDataBusWidth / 64);

	for (i=0,Position=0;i<2;i++) {
		*((PULONG)(FBAddress+Position))=Position;
		Position += Increment;
	}

	for (i=0,Position=0;i<2;i++) {
		if ( (*(PULONG) (FBAddress + Position)) !=Position)
			return 0;
		Position += Increment;
	}
	return 1;
}

int SiSCheckBanks(int index,USHORT DRAMTYPE_TABLE[][5],ULONG FBAddress)
{
	int i;
	ULONG Increment,Position;
	Increment = 1<<(DRAMTYPE_TABLE[index][2] + SiSDataBusWidth / 64 + 2);

	for (i=0,Position=0;i<4;i++) {
		*((PULONG)(FBAddress+Position))=Position;
		Position += Increment;
	}

	for (i=0,Position=0;i<4;i++) {
		if ( (*(PULONG) (FBAddress + Position)) !=Position)
			return 0;
		Position += Increment;
	}
	return 1;
}

int SiSCheckRank(int RankNo,int index,USHORT DRAMTYPE_TABLE[][5],ULONG FBAddress)
{
	int i;
	ULONG Increment,Position;
	Increment = 1<<(DRAMTYPE_TABLE[index][2] + DRAMTYPE_TABLE[index][1] +
	                DRAMTYPE_TABLE[index][0] + SiSDataBusWidth / 64 + RankNo);

	for (i=0,Position=0;i<2;i++) {
		*((PULONG)(FBAddress+Position))=Position;
		Position += Increment;
	}

	for (i=0,Position=0;i<2;i++) {
		if ( (*(PULONG) (FBAddress + Position)) != Position)
			return 0;
		Position += Increment;
	}
	return 1;

}

int SiSCheckRanks(int RankNo,int index,USHORT DRAMTYPE_TABLE[][5],ULONG FBAddress)
{
	int r;

	for (r=RankNo;r>=1;r--) {
		if (!SiSCheckRank(r,index,DRAMTYPE_TABLE,FBAddress))
			return 0;
	}
	if (!SiSCheckBanks(index,DRAMTYPE_TABLE,FBAddress))
		return 0;

	if (!SiSCheckColumn(index,DRAMTYPE_TABLE,FBAddress))
		return 0;

	return 1;
}


int SiSSDRSizing(ULONG FBAddress)
{
	int    i;
	UCHAR  j;

	for (i=0;i<11;i++) {
		SiSSetDRAMSizingType(i, SIS_SDRDRAM_TYPE);
		for (j=2;j>0;j--) {
			if (!SiSSetRank(i,(UCHAR) j, SiSChannelAB,SIS_SDRDRAM_TYPE))
				continue;
			else {
				if (SiSCheckRanks(j,i,SIS_SDRDRAM_TYPE, FBAddress))
				return 1;
			}
		}
	}
	return 0;
}

int SiSDDRSizing(ULONG FBAddress)
{

	int    i;
	UCHAR  j;

	for (i=0;i<4;i++) {
		SiSSetDRAMSizingType(i,SIS_DDRDRAM_TYPE);
		SiSDisableChannelInterleaving(i,SIS_DDRDRAM_TYPE);
		for (j=2;j>0;j--) {

			SiSSetDDRChannel(i, j, SiSChannelAB, SIS_DDRDRAM_TYPE);
			if (!SiSSetRank(i,(UCHAR) j, SiSChannelAB,SIS_SDRDRAM_TYPE))
				continue;
			else {
				if (SiSCheckRanks(j,i,SIS_SDRDRAM_TYPE, FBAddress))
				return 1;
			}
		}
	}
	return 0;
}

VOID SiSVerifyMclk(ULONG FBAddr)
{
	PUCHAR  pVideoMemory = (PUCHAR) FBAddr;
	UCHAR i,j;
	USHORT Temp,SR21;


	pVideoMemory[0]=0xaa; 
	pVideoMemory[16]=0x55; 

	if ((pVideoMemory[0]!=0xaa)||(pVideoMemory[16]!=0x55)) {
		for (i=0,j=16;i<2;i++,j+=16) {
			SR21 = SiSGetReg1(SiSP3c4, 0x21);
			Temp = SR21 & 0xFB;     
			SiSSetReg1(SiSP3c4, 0x21, Temp);

			Temp = SiSGetReg1(SiSP3c4, 0x3C);
			Temp = Temp | 0x01;                 
			SiSSetReg1(SiSP3c4, 0x3C, Temp);
			Temp = SiSGetReg1(SiSP3c4, 0x3C);
			Temp = Temp & 0xFE;                 
			SiSSetReg1(SiSP3c4, 0x3C, Temp);
			SiSSetReg1(SiSP3c4, 0x21, SR21);

			pVideoMemory[16+j] = j;
			if (pVideoMemory[16+j]==j) {
				pVideoMemory[j] = j;
				break;
			}
		}
	}
}

VOID SiSSetDRAMSize(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	ULONG   ROMAddr  = (ULONG)HwDeviceExtension->VirtualRomBase;
	ULONG   FBAddr   = (ULONG)HwDeviceExtension->VirtualVideoMemoryAddress;
	USHORT  data;

#ifdef SIS301
   
#else
#ifdef SIS302
	SiSSetReg1(SiSP3d4,0x30,0x4D);  
	SiSSetReg1(SiSP3d4,0x31,0xc0);  
	SiSSetReg1(SiSP3d4,0x34,0x3F);  
#endif
#endif
	SiSSetMode310(HwDeviceExtension,0x2e);

	data=SiSGetReg1(SiSP3c4,0x21);
	SiSSetReg1(SiSP3c4,0x21,(USHORT) (data&0xDF));      

	data=SiSGetReg1(SiSP3c4,0x1);
	data=data|0x20;
	SiSSetReg1(SiSP3c4,0x01,data);                    

	data=SiSGetReg1(SiSP3c4,0x16);
	SiSSetReg1(SiSP3c4,0x16,(USHORT) (data|0x0F));      

	SiSSetDRAMModeRegister(ROMAddr);
	SiSDisableRefresh();
	SiSCheckBusWidth(ROMAddr,FBAddr);
	SiSVerifyMclk(FBAddr); 

	if (SiSGet310DRAMType(ROMAddr)<2) {
		SiSSDRSizing(FBAddr);
	} else {
		SiSDDRSizing(FBAddr);
	}

	data=*((UCHAR *)(ROMAddr+SR16_OFFSET+SiSRAMType));
	SiSSetReg1(SiSP3c4,0x16,data);  

	SiSEnableRefresh(ROMAddr);
	data=SiSGetReg1(SiSP3c4,0x21);
	SiSSetReg1(SiSP3c4,0x21,(USHORT) (data|0x20));      
}

VOID SiSSetMemoryClock(ULONG ROMAddr)
{
	UCHAR data,i;

	SiSMCLKData=*((USHORT *)(ROMAddr+MCLKDataPtrOffset));              
	SiSMCLKData=SiSMCLKData+SiSRAMType*5;
	SiSECLKData=SiSMCLKData+ECLK_MCLK_DISTANCE;

	for(i=0x28;i<=0x2A;i++) {                         
		data=*((UCHAR *)(ROMAddr+SiSMCLKData));
		SiSSetReg1(SiSP3c4,i,data);
		SiSMCLKData++;
	}

	for(i=0x2E;i<=0x30;i++) {                         
		data=*((UCHAR *)(ROMAddr+SiSECLKData));
		SiSSetReg1(SiSP3c4,i,data);
		SiSECLKData++;
	}
}

BOOLEAN SiSSetMode310(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT ModeNo)
{
	ULONG   temp;
	USHORT  cr30flag,cr31flag;
	ULONG   ROMAddr  = (ULONG)HwDeviceExtension->VirtualRomBase;
	USHORT  BaseAddr = (USHORT)HwDeviceExtension->IOAddress;

	SiSP3c4=BaseAddr+0x14;
	SiSP3d4=BaseAddr+0x24;
	SiSP3c0=BaseAddr+0x10;
	SiSP3ce=BaseAddr+0x1e;
	SiSP3c2=BaseAddr+0x12;
	SiSP3ca=BaseAddr+0x1a;
	SiSP3c6=BaseAddr+0x16;
	SiSP3c7=BaseAddr+0x17;
	SiSP3c8=BaseAddr+0x18;
	SiSP3c9=BaseAddr+0x19;
	SiSP3da=BaseAddr+0x2A;
	if (ModeNo&0x80) {
		ModeNo=ModeNo&0x7F;
		SiS_flag_clearbuffer=0;        
	} else {
		SiS_flag_clearbuffer=1;
	}

	SiSPresetScratchregister301(SiSP3d4,HwDeviceExtension); 

	SiSSetReg1(SiSP3c4,0x05,0x86);                     
	temp=SiSSearchModeID(ROMAddr,ModeNo);           
	if (temp==0)  return(0);
   
	SiSSetTVSystem301(HwDeviceExtension,ROMAddr);                               
	SiSGetLCDDDCInfo301(HwDeviceExtension);            
	SiSGetVBInfo301(BaseAddr,ROMAddr);                 
	SiSGetLCDResInfo301(ROMAddr,SiSP3d4);                         

	temp=SiSCheckMemorySize(ROMAddr);               
	if (temp==0) return(0);
	cr30flag=(UCHAR)SiSGetReg1(SiSP3d4,0x30);
	if (((cr30flag&0x01)==1)||((cr30flag&0x02)==0)) {
		SiSSetReg1(SiSP3d4,0x34,ModeNo); 
     
		SiSGetModePtr(ROMAddr,ModeNo);                  
		SiSSetSeqRegs(ROMAddr);                         
		SiSSetMiscRegs(ROMAddr);                        
		SiSSetCRTCRegs(ROMAddr);                        
		SiSSetATTRegs(ROMAddr);                         
		SiSSetGRCRegs(ROMAddr);                         
		SiSClearExt1Regs();                             
		temp=SiSGetRatePtr(ROMAddr,ModeNo);             
		if (temp) {
			SiSSetSync(ROMAddr);                          
			SiSSetCRT1CRTC(ROMAddr);                      
			SiSSetCRT1Offset(ROMAddr);                    
			SiSSetCRT1VCLK(HwDeviceExtension, ROMAddr);                      
			SiSSetVCLKState(HwDeviceExtension, ROMAddr, ModeNo);
			if (HwDeviceExtension->jChipID > SIS_GlamourII)
				SiSSetCRT1FIFO2(ROMAddr,HwDeviceExtension);
			else
				SiSSetCRT1FIFO(ROMAddr,ModeNo,HwDeviceExtension);
		}
		SiSSetCRT1ModeRegs(ROMAddr, ModeNo);
		if (HwDeviceExtension->jChipID > SIS_GlamourII)
			SiSSetInterlace(ROMAddr,ModeNo);
		SiSLoadDAC(ROMAddr);
		if (SiS_flag_clearbuffer) SiSClearBuffer(HwDeviceExtension);
	}
	cr31flag=(UCHAR)SiSGetReg1(SiSP3d4,0x31);
	if (((cr30flag&0x01)==1)||((cr30flag&0x03)==0x02)
     ||(((cr30flag&0x03)==0x00)&&((cr31flag&0x20)==0x20))) {
		switch (HwDeviceExtension->hasVB) {
		case HASVB_301:
			SiSSetCRT2Group301(BaseAddr,ROMAddr,ModeNo, HwDeviceExtension);                     
			break;
		case HASVB_302:
		case HASVB_303:
			break;
		default:
			break;
		}
	}
	SiSDisplayOn();                                 
	return(NO_ERROR);
}


BOOLEAN SiSSearchModeID(ULONG ROMAddr, USHORT ModeNo)
{
	UCHAR ModeID;
	USHORT  usIDLength;

	SiSModeIDOffset=*((USHORT *)(ROMAddr+EModeIDTablePtrOffset));
	ModeID=*((UCHAR *)(ROMAddr+SiSModeIDOffset));      
	usIDLength = SiSGetModeIDLength(ROMAddr, ModeNo);
	while(ModeID!=0xff && ModeID!=ModeNo) {
		SiSModeIDOffset=SiSModeIDOffset+usIDLength;
		ModeID=*((UCHAR *)(ROMAddr+SiSModeIDOffset));
	}
	if (ModeID==0xff) return(FALSE);
	else return(TRUE);
}

BOOLEAN SiSCheckMemorySize(ULONG ROMAddr)
{
	USHORT memorysize;
	USHORT modeflag;
	USHORT temp;

	modeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   
	SiSModeType=modeflag&ModeInfoFlag;                      

	memorysize=modeflag&MemoryInfoFlag;
	memorysize=memorysize>MemorySizeShift;
	memorysize++;                                        

	temp=SiSGetReg1(SiSP3c4,0x14);                             
  
	if ((temp&0x0c)!=0) {
		temp=1 << ((temp&0x0F0)>>4);
		temp <<= 1;
	} else {
		temp=1 << ((temp&0x0F0)>>4);
	}

	if (temp<memorysize) return(FALSE);
	else return(TRUE);
}

VOID SiSGetModePtr(ULONG ROMAddr, USHORT ModeNo)
{
	UCHAR index;

	SiSStandTable=*((USHORT *)(ROMAddr+StandTablePtrOffset));

	if (ModeNo<=13) {
		index=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x03));   
	} else {
		if (SiSModeType <= 0x02) index=0x1B;                
		else index=0x0F;
	}

	SiSStandTable=SiSStandTable+64*index;       
}

VOID SiSSetSeqRegs(ULONG ROMAddr)
{
	UCHAR SRdata;
	USHORT i;

	SiSSetReg1(SiSP3c4,0x00,0x03);                        
	SiSStandTable=SiSStandTable+0x05;
	SRdata=*((UCHAR *)(ROMAddr+SiSStandTable));         
	if (SIS_IF_DEF_LVDS==1) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (SiSVBInfo&SetInSlaveMode) {
				if (SiSLCDInfo&LCDNonExpanding) {
					SRdata=SRdata|0x01;
				}
			}
		}
	}

	SRdata=SRdata|0x20;
	SiSSetReg1(SiSP3c4,0x01,SRdata);                      
	for(i=02;i<=04;i++) {
		SiSStandTable++;
		SRdata=*((UCHAR *)(ROMAddr+SiSStandTable));       
		SiSSetReg1(SiSP3c4,i,SRdata);                       
	}
}

VOID SiSSetMiscRegs(ULONG ROMAddr)
{
	UCHAR Miscdata;

	SiSStandTable++;
	Miscdata=*((UCHAR *)(ROMAddr+SiSStandTable));       
	SiSSetReg3(SiSP3c2,Miscdata);                         
}

VOID SiSSetCRTCRegs(ULONG ROMAddr)
{
	UCHAR CRTCdata;
	USHORT i;

	CRTCdata=(UCHAR)SiSGetReg1(SiSP3d4,0x11);
	CRTCdata=CRTCdata&0x7f;
	SiSSetReg1(SiSP3d4,0x11,CRTCdata);                     

	for(i=0;i<=0x18;i++) {
		SiSStandTable++;
		CRTCdata=*((UCHAR *)(ROMAddr+SiSStandTable));     
		SiSSetReg1(SiSP3d4,i,CRTCdata);                     
	}
}

VOID SiSSetATTRegs(ULONG ROMAddr)
{
	UCHAR ARdata;
	USHORT i;

	for(i=0;i<=0x13;i++) {
		SiSStandTable++;
		ARdata=*((UCHAR *)(ROMAddr+SiSStandTable));     
		if (SIS_IF_DEF_LVDS==1) {  
			if (SiSVBInfo&SetCRT2ToLCD) {
				if (SiSVBInfo&SetInSlaveMode) {
					if (SiSLCDInfo&LCDNonExpanding) {
						if (i==0x13) {
							ARdata=0;
						}
					}
				}
			}
		}
		SiSGetReg2(SiSP3da);                              
		SiSSetReg3(SiSP3c0,i);                            
		SiSSetReg3(SiSP3c0,ARdata);                       
	}
	if (SIS_IF_DEF_LVDS==1) {  
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (SiSVBInfo&SetInSlaveMode) {
				if (SiSLCDInfo&LCDNonExpanding) {
		           
				}
			}
		}
	}
	SiSGetReg2(SiSP3da);                                
	SiSSetReg3(SiSP3c0,0x14);                           
	SiSSetReg3(SiSP3c0,0x00);                           

	SiSGetReg2(SiSP3da);                                
	SiSSetReg3(SiSP3c0,0x20);
}

VOID SiSSetGRCRegs(ULONG ROMAddr)
{
	UCHAR GRdata;
	USHORT i;

	for(i=0;i<=0x08;i++) {
		SiSStandTable++;
		GRdata=*((UCHAR *)(ROMAddr+SiSStandTable));     
		SiSSetReg1(SiSP3ce,i,GRdata);                     
	}
	if (SiSModeType>ModeVGA) {
		GRdata=(UCHAR)SiSGetReg1(SiSP3ce,0x05);
		GRdata=GRdata&0xBF;
		SiSSetReg1(SiSP3ce,0x05,GRdata); 
	}
}

VOID SiSClearExt1Regs()
{
	USHORT i;

	for(i=0x0A;i<=0x0E;i++) SiSSetReg1(SiSP3c4,i,0x00);      
}


BOOLEAN SiSGetRatePtr(ULONG ROMAddr, USHORT ModeNo)
{
	SHORT  index;
	USHORT temp;
	USHORT ulRefIndexLength;

	if (ModeNo<0x14) return(FALSE);                           

	index=SiSGetReg1(SiSP3d4,0x33);                            
	index=index&0x0F;                                    
	if (index!=0) index--;

	SiSREFIndex=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x05));   

	ulRefIndexLength = SiSGetRefindexLength(ROMAddr, ModeNo);
	do {
		temp=*((USHORT *)(ROMAddr+SiSREFIndex));                
		if (temp==0xFFFF) break;
		temp=temp&ModeInfoFlag;
		if (temp<SiSModeType) break;

		SiSREFIndex=SiSREFIndex+ulRefIndexLength;                  
		index--;
	} while(index>=0);

	SiSREFIndex=SiSREFIndex-ulRefIndexLength;                    
	return(TRUE);
}

VOID SiSSetSync(ULONG ROMAddr)
{
	USHORT sync;
	USHORT temp;

	sync=*((USHORT *)(ROMAddr+SiSREFIndex));                
	sync=sync&0xC0;
	temp=0x2F;
	temp=temp|sync;
	SiSSetReg3(SiSP3c2,temp);                                 
}

VOID SiSSetCRT1CRTC(ULONG ROMAddr)
{
	UCHAR  index;
	UCHAR  data;
	USHORT i;

	index=*((UCHAR *)(ROMAddr+SiSREFIndex+0x02));          
	SiSCRT1Table=*((USHORT *)(ROMAddr+CRT1TablePtrOffset));              
	SiSCRT1Table=SiSCRT1Table+index*CRT1Len;

	data=(UCHAR)SiSGetReg1(SiSP3d4,0x11);
	data=data&0x7F;
	SiSSetReg1(SiSP3d4,0x11,data);                             

	SiSCRT1Table--;
	for(i=0;i<=0x05;i++) {
		SiSCRT1Table++;
		data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
		SiSSetReg1(SiSP3d4,i,data);
	}
	for(i=0x06;i<=0x07;i++) {
		SiSCRT1Table++;
		data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
		SiSSetReg1(SiSP3d4,i,data);
	}
	for(i=0x10;i<=0x12;i++) {
		SiSCRT1Table++;
		data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
		SiSSetReg1(SiSP3d4,i,data);
	}
	for(i=0x15;i<=0x16;i++) {
		SiSCRT1Table++;
		data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
		SiSSetReg1(SiSP3d4,i,data);
	}
	for(i=0x0A;i<=0x0C;i++) {
		SiSCRT1Table++;
		data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
		SiSSetReg1(SiSP3c4,i,data);
	}

	SiSCRT1Table++;
	data=*((UCHAR *)(ROMAddr+SiSCRT1Table));
	data=data&0xE0;
	SiSSetReg1(SiSP3c4,0x0E,data);

	data=(UCHAR)SiSGetReg1(SiSP3d4,0x09);
	data=data&0xDF;
	i=*((UCHAR *)(ROMAddr+SiSCRT1Table));
	i=i&0x01;
	i=i<<5;
	data=data|i;
	i=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	i=i&DoubleScanMode;
	if (i) data=data|0x80;
	SiSSetReg1(SiSP3d4,0x09,data);

	if (SiSModeType>0x03) SiSSetReg1(SiSP3d4,0x14,0x4F);
}

VOID SiSSetCRT1Offset(ULONG ROMAddr)
{
	USHORT temp,ah,al;
	USHORT temp2,i;
	USHORT DisplayUnit;

   
	temp=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x03));         
	temp=temp>>8;                                         
	SiSScreenOffset=*((USHORT *)(ROMAddr+ScreenOffsetPtrOffset));            
	temp=*((UCHAR *)(ROMAddr+SiSScreenOffset+temp));         

	temp2=*((USHORT *)(ROMAddr+SiSREFIndex+0x00));
	temp2=temp2&InterlaceMode;
	if (temp2) temp=temp<<1;
	temp2=SiSModeType-ModeEGA;
	switch (temp2) {
	case 0 : temp2=1; break;
	case 1 : temp2=2; break;
	case 2 : temp2=4; break;
	case 3 : temp2=4; break;
	case 4 : temp2=6; break;
	case 5 : temp2=8; break;
	}
	temp=temp*temp2;
	DisplayUnit=temp;

	temp2=temp;
	temp=temp>>8;                                         
	temp=temp&0x0F;
	i=SiSGetReg1(SiSP3c4,0x0E);
	i=i&0xF0;
	i=i|temp;
	SiSSetReg1(SiSP3c4,0x0E,i);

	temp=(UCHAR)temp2;
	temp=temp&0xFF;                                        
	SiSSetReg1(SiSP3d4,0x13,temp);

	temp2=*((USHORT *)(ROMAddr+SiSREFIndex+0x00));
	temp2=temp2&InterlaceMode;
	if (temp2) DisplayUnit>>=1;

	DisplayUnit=DisplayUnit<<5;
	ah=(DisplayUnit&0xff00)>>8;
	al=DisplayUnit&0x00ff;
	if (al==0) ah=ah+1;
	else ah=ah+2;
	SiSSetReg1(SiSP3c4,0x10,ah);
}

VOID SiSSetCRT1VCLK(PHW_DEVICE_EXTENSION HwDeviceExtension, ULONG ROMAddr)
{
	USHORT i;
	UCHAR  index,data;

	index=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));
	SiSCRT1VCLKLen=SiSGetVCLKLen(ROMAddr,HwDeviceExtension);
	data=index*SiSCRT1VCLKLen;
	SiSVCLKData=*((USHORT *)(ROMAddr+VCLKDataPtrOffset));
	SiSVCLKData=SiSVCLKData+data;

	SiSSetReg1(SiSP3c4,0x31,0);
  
  
	for(i=0x2B;i<=0x2C;i++) {
		data=*((UCHAR *)(ROMAddr+SiSVCLKData));
		SiSSetReg1(SiSP3c4,i,data);
		SiSVCLKData++;
    }
	SiSSetReg1(SiSP3c4,0x2D,0x80);
}

VOID SiSIsLowResolution(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT data;
	USHORT ModeFlag;


	data = SiSGetReg1(SiSP3c4,0x0F);
	data = data&0x7F;
	SiSSetReg1(SiSP3c4,0x0F,data);

	if (ModeNo>0x13) {
		ModeFlag = *((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      
		if ((ModeFlag & HalfDCLK) && (ModeFlag & DoubleScanMode)) {
			data = SiSGetReg1(SiSP3c4,0x0F);
			data = data|0x80;
			SiSSetReg1(SiSP3c4,0x0F,data);
			data = SiSGetReg1(SiSP3c4,0x01);
			data = data&0xF7;
			SiSSetReg1(SiSP3c4,0x01,data);
		}
	}
}

VOID SiSSetCRT1ModeRegs(ULONG ROMAddr, USHORT ModeNo)
{
	USHORT data,data2,data3;

	if (ModeNo>0x13)   data=*((USHORT *)(ROMAddr+SiSREFIndex+0x00));
	else data=0;

	data2=0;
	if (ModeNo>0x13)
		if (SiSModeType>0x02) {
			data2=data2|0x02;
			data3=SiSModeType-ModeVGA;
			data3=data3<<2;
			data2=data2|data3;
		}

	data=data&InterlaceMode;
	if (data) data2=data2|0x20;
	SiSSetReg1(SiSP3c4,0x06,data2);

	data=SiSGetReg1(SiSP3c4,0x01);
	data=data&0xF7;
	data2=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	data2=data2&HalfDCLK;
	if (data2) data=data|0x08;
	SiSSetReg1(SiSP3c4,0x01,data);

	data=SiSGetReg1(SiSP3c4,0x0F);
	data=data&0xF7;
	data2=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	data2=data2&LineCompareOff;
	if (data2) data=data|0x08;
	SiSSetReg1(SiSP3c4,0x0F,data);

	data=SiSGetReg1(SiSP3c4,0x21);
	data=data&0x1F;
	if (SiSModeType==0x00) data=data|0x60;                
	else if (SiSModeType<=0x02) data=data|0x00;           
	else data=data|0xA0;                              
	SiSSetReg1(SiSP3c4,0x21,data);
}

VOID SiSSetVCLKState(PHW_DEVICE_EXTENSION HwDeviceExtension, ULONG ROMAddr, USHORT ModeNo)
{
	USHORT data,data2;
	USHORT VCLK;
	UCHAR  index;

	index=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));
	SiSCRT1VCLKLen=SiSGetVCLKLen(ROMAddr,HwDeviceExtension);
	data=index*SiSCRT1VCLKLen;
	SiSVCLKData=*((USHORT *)(ROMAddr+VCLKDataPtrOffset));
  
	SiSVCLKData=SiSVCLKData+data+(SiSCRT1VCLKLen-2);

	VCLK=*((USHORT *)(ROMAddr+SiSVCLKData));
	if (ModeNo<=0x13) VCLK=0;

	data=SiSGetReg1(SiSP3c4,0x32);
	data=data&0xf3;
	if (VCLK>=200) data=data|0x0c;  
	SiSSetReg1(SiSP3c4,0x32,data);

	data2=0x03;
	if (VCLK>135) data2=0x02;
	if (VCLK>160) data2=0x01;
	if (VCLK>260) data2=0x00;
	data=SiSGetReg1(SiSP3c4,0x07);
   
	data &= 0xFB;

	data=data&0xFC;
	data=data|data2;
	SiSSetReg1(SiSP3c4,0x07,data);
}

VOID SiSLoadDAC(ULONG ROMAddr)
{
	USHORT data,data2;
	USHORT time,i,j,k;
	USHORT m,n,o;
	USHORT si,di,bx,dl;
	USHORT al,ah,dh;
	USHORT *table=SIS_VGA_DAC;

	data=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	data=data&DACInfoFlag;
	time=64;
	if (data==0x00) table=SIS_MDA_DAC;
	if (data==0x08) table=SIS_CGA_DAC;
	if (data==0x10) table=SIS_EGA_DAC;
	if (data==0x18) {
		time=256;
		table=SIS_VGA_DAC;
	}
	if (time==256) j=16;
	else j=time;

	SiSSetReg3(SiSP3c6,0xFF);
	SiSSetReg3(SiSP3c8,0x00);

	for(i=0;i<j;i++) {
		data=table[i];
		for(k=0;k<3;k++) {
			data2=0;
			if (data&0x01) data2=0x2A;
			if (data&0x02) data2=data2+0x15;
			SiSSetReg3(SiSP3c9,data2);
			data=data>>2;
		}
	}

	if (time==256) {
		for(i=16;i<32;i++) {
			data=table[i];
			for(k=0;k<3;k++) SiSSetReg3(SiSP3c9,data);
		}
		si=32;
		for(m=0;m<9;m++) {
			di=si;
			bx=si+0x04;
			dl=0;
			for(n=0;n<3;n++) {
				for(o=0;o<5;o++) {
					dh=table[si];
					ah=table[di];
					al=table[bx];
					si++;
					SiSWriteDAC(dl,ah,al,dh);
				}         
				si=si-2;
				for(o=0;o<3;o++) {
					dh=table[bx];
					ah=table[di];
					al=table[si];
					si--;
					SiSWriteDAC(dl,ah,al,dh);
				}         
            	dl++;
			}
			si=si+5;
		}               
	}
}

VOID SiSWriteDAC(USHORT dl, USHORT ah, USHORT al, USHORT dh)
{
	USHORT temp;
	USHORT bh,bl;

	bh=ah;
	bl=al;
	if (dl!=0) {
		temp=bh;
		bh=dh;
		dh=temp;
		if (dl==1) {
			temp=bl;
			bl=dh;
			dh=temp;
		} else {
			temp=bl;
			bl=bh;
			bh=temp;
		}
	}
	SiSSetReg3(SiSP3c9,(USHORT)dh);
	SiSSetReg3(SiSP3c9,(USHORT)bh);
	SiSSetReg3(SiSP3c9,(USHORT)bl);
}

VOID SiSDisplayOn()
{
	USHORT data;

	data=SiSGetReg1(SiSP3c4,0x01);
	data=data&0xDF;
	SiSSetReg1(SiSP3c4,0x01,data);
}

USHORT SiSGetModeIDLength(ULONG ROMAddr, USHORT ModeNo)
{
	UCHAR  ModeID;
	USHORT modeidlength;
	USHORT usModeIDOffset;

	modeidlength=0;
	usModeIDOffset=*((USHORT *)(ROMAddr+EModeIDTablePtrOffset));
	ModeID=*((UCHAR *)(ROMAddr+usModeIDOffset));     
	while(ModeID!=0x2E) {
		modeidlength++;
		usModeIDOffset=usModeIDOffset+1;               
		ModeID=*((UCHAR *)(ROMAddr+usModeIDOffset));
	}
	return(modeidlength);
}

USHORT SiSGetRefindexLength(ULONG ROMAddr, USHORT ModeNo)
{
	UCHAR ModeID;
	UCHAR temp;
	USHORT refindexlength;
	USHORT usModeIDOffset;
	USHORT usREFIndex;
	USHORT usIDLength;

	usModeIDOffset=*((USHORT *)(ROMAddr+EModeIDTablePtrOffset));
	ModeID=*((UCHAR *)(ROMAddr+usModeIDOffset));           
	usIDLength = SiSGetModeIDLength(ROMAddr, ModeNo);
	while(ModeID!=0x40) {
		usModeIDOffset=usModeIDOffset+usIDLength; 
		ModeID=*((UCHAR *)(ROMAddr+usModeIDOffset));
	}

	refindexlength=1;
	usREFIndex=*((USHORT *)(ROMAddr+usModeIDOffset+0x05));   
	usREFIndex++;
	temp=*((UCHAR *)(ROMAddr+usREFIndex));                 
	while(temp!=0xFF) {
		refindexlength++;
		usREFIndex++;
		temp=*((UCHAR *)(ROMAddr+usREFIndex));              
	}
	return(refindexlength);
}

VOID SiSSetInterlace(ULONG ROMAddr, USHORT ModeNo)
{
	ULONG Temp;
	USHORT data,Temp2;

	Temp = (ULONG)SiSGetReg1(SiSP3d4, 0x01);
	Temp++;
	Temp=Temp*8;

	if (Temp==1024) data=0x0035;
	else if (Temp==1280) data=0x0048;
	else data=0x0000;

	Temp2=*((USHORT *)(ROMAddr+SiSREFIndex+0x00));
	Temp2 &= InterlaceMode;
	if (Temp2 == 0) data=0x0000;

	SiSSetReg1(SiSP3d4,0x19,data);

	Temp = (ULONG)SiSGetReg1(SiSP3d4, 0x1A);
	Temp2= (USHORT)(Temp & 0xFC);
	SiSSetReg1(SiSP3d4,0x1A,(USHORT)Temp);

	Temp = (ULONG)SiSGetReg1(SiSP3c4, 0x0f);
	Temp2= (USHORT)Temp & 0xBF;
	if (ModeNo==0x37) Temp2=Temp2|0x40;
	SiSSetReg1(SiSP3d4,0x1A,(USHORT)Temp2);
}

VOID SiSSetCRT1FIFO(ULONG ROMAddr,USHORT ModeNo,PHW_DEVICE_EXTENSION HwDeviceExtension)
{

	USHORT  data;

	data=SiSGetReg1(SiSP3c4,0x3D);
	data &= 0xfe;
	SiSSetReg1(SiSP3c4,0x3D,data);  
	if (ModeNo>0x13)
	{
		SiSSetReg1(SiSP3c4,0x08,0x14);
		data=SiSGetReg1(SiSP3c4,0x09);
		data &= 0xF0;
		SiSSetReg1(SiSP3c4,0x09,data);

		data=SiSGetReg1(SiSP3c4,0x3D);
		data |= 0x01;
		SiSSetReg1(SiSP3c4,0x3D,data);
	} else {
		SiSSetReg1(SiSP3c4,0x08,0xAE);
		data=SiSGetReg1(SiSP3c4,0x09);
		data &= 0xF0;
		SiSSetReg1(SiSP3c4,0x09,data);
	}
}

USHORT SiSCalcDelay(ULONG ROMAddr,USHORT key)
{
	USHORT data,data2,temp0,temp1;
	UCHAR   ThLowA[]=   {61,3,52,5,68,7,100,11,
	                     43,3,42,5,54,7, 78,11,
	                     34,3,37,5,47,7, 67,11};
	UCHAR   ThLowB[]=   {81,4,72,6,88,8,120,12,
	                     55,4,54,6,66,8, 90,12,
	                     42,4,45,6,55,8, 75,12};
	UCHAR   ThTiming[]= {1,2,2,3,0,1,1,2};

	data=SiSGetReg1(SiSP3c4,0x16);
	data=data>>6;
	data2=SiSGetReg1(SiSP3c4,0x14);
	data2=(data2>>4)&0x0C;
	data=data|data2;
	data=data<1;
	if (key==0) {
		temp0=(USHORT)ThLowA[data];
		temp1=(USHORT)ThLowA[data+1];
	} else {
		temp0=(USHORT)ThLowB[data];
		temp1=(USHORT)ThLowB[data+1];
	}

	data2=0;
	data=SiSGetReg1(SiSP3c4,0x18);
	if (data&0x02) data2=data2|0x01;
	if (data&0x20) data2=data2|0x02;
	if (data&0x40) data2=data2|0x04;

	data=temp1*ThTiming[data2]+temp0;
	return(data);
}

VOID SiSSetCRT1FIFO2(ULONG ROMAddr,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT  index,data,VCLK,data2,MCLKOffset,MCLK,colorth=0;
	USHORT  ah,bl,B;
	ULONG   eax;

	index=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));
	SiSCRT1VCLKLen=SiSGetVCLKLen(ROMAddr,HwDeviceExtension);
	data=index*SiSCRT1VCLKLen;
	SiSVCLKData=*((USHORT *)(ROMAddr+0x208));
	SiSVCLKData=SiSVCLKData+data+(SiSCRT1VCLKLen-2);
	VCLK=*((USHORT *)(ROMAddr+SiSVCLKData));           

	MCLKOffset=*((USHORT *)(ROMAddr+0x20C));
	index=SiSGetReg1(SiSP3c4,0x1A);
	index=index&07;
	MCLKOffset=MCLKOffset+index*5;
	MCLK=*((USHORT *)(ROMAddr+MCLKOffset+0x03));     

	data2=SiSModeType-0x02;
	switch (data2) {
	case 0 : colorth=1; break;
	case 1 : colorth=1; break;
	case 2 : colorth=2; break;
	case 3 : colorth=2; break;
	case 4 : colorth=3; break;
	case 5 : colorth=4; break;
    }

	do{
		B=(SiSCalcDelay2(ROMAddr,0)*VCLK*colorth);
		if (B%(16*MCLK) == 0) {
			B=B/(16*MCLK);
			bl=B+1;
		} else {
			B=B/(16*MCLK);
			bl=B+2;
		}

		if (bl>0x13) {
			data=SiSGetReg1(SiSP3c4,0x15);
			data=data&0xf0;
			if (data!=0xb0) {
				data=data+0x20;
				if (data==0xa0) data=0x30;

				data2=SiSGetReg1(SiSP3c4,0x15);
				data2=(data2&0x0f)|data;
				SiSSetReg1(SiSP3c4,0x15,data2);
			} else 
				bl=0x13;
		}
	} while(bl>0x13);

	data2=SiSGetReg1(SiSP3c4,0x15);
	data2=(data2&0xf0)>>4;
	data2=data2<<24;

	SiSSetReg4(0xcf8,0x80000050);
	eax=SiSGetReg3(0xcfc);
	eax=eax&0x0f0ffffff;
	eax=eax|data2;
	SiSSetReg4(0xcfc,eax);

	ah=bl;
	ah=ah<<4;
	ah=ah|0x0f;
	SiSSetReg1(SiSP3c4,0x08,ah);

	data=bl;
	data=data&0x10;
	data=data<<1;
	data2=SiSGetReg1(SiSP3c4,0x0F);
	data2=data2&0x9f;
	data2=data2|data;
	SiSSetReg1(SiSP3c4,0x0F,data2);

	data=bl+3;
	if (data>0x0f) data=0x0f;
	SiSSetReg1(SiSP3c4,0x3b,0x00);
	data2=SiSGetReg1(SiSP3c4,0x09);
	data2=data2&0xF0;
	data2=data2|data;
	SiSSetReg1(SiSP3c4,0x09,data2);
}

USHORT SiSCalcDelay2(ULONG ROMAddr,USHORT key)
{
	USHORT data,index;
	UCHAR  LatencyFactor[]={88,80,78,72,70,00,
	                        00,79,77,71,69,49,
	                        88,80,78,72,70,00,
	                        00,72,70,64,62,44};

	index=0;
	data=SiSGetReg1(SiSP3c4,0x14);
	if (data&0x80) index=index+12;

	data=SiSGetReg1(SiSP3c4,0x15);
	data=(data&0xf0)>>4;
	if (data&0x01) index=index+6;

	data=data>>1;
	index=index+data;
	data=LatencyFactor[index];

	return(data);
}


